/* animate-timer.c generated by valac 0.15.1, the Vala compiler
 * generated from animate-timer.vala, do not modify */

/* -*- Mode: Vala; indent-tabs-mode: nil; tab-width: 4 -*-
 *
 * Copyright (C) 2011,2012 Canonical Ltd
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 3 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authors: Robert Ancell <robert.ancell@canonical.com>
 *          Michael Terry <michael.terry@canonical.com>
 */

#include <glib.h>
#include <glib-object.h>
#include <float.h>
#include <math.h>


#define TYPE_ANIMATE_TIMER (animate_timer_get_type ())
#define ANIMATE_TIMER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ANIMATE_TIMER, AnimateTimer))
#define ANIMATE_TIMER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ANIMATE_TIMER, AnimateTimerClass))
#define IS_ANIMATE_TIMER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ANIMATE_TIMER))
#define IS_ANIMATE_TIMER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ANIMATE_TIMER))
#define ANIMATE_TIMER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ANIMATE_TIMER, AnimateTimerClass))

typedef struct _AnimateTimer AnimateTimer;
typedef struct _AnimateTimerClass AnimateTimerClass;
typedef struct _AnimateTimerPrivate AnimateTimerPrivate;

struct _AnimateTimer {
	GObject parent_instance;
	AnimateTimerPrivate * priv;
};

struct _AnimateTimerClass {
	GObjectClass parent_class;
};

struct _AnimateTimerPrivate {
	gint _speed;
	gdouble _progress;
	guint timeout;
	GTimeSpan start_time;
	GTimeSpan length;
	GTimeSpan extra_time;
	gdouble extra_progress;
};


static gpointer animate_timer_parent_class = NULL;

GType animate_timer_get_type (void) G_GNUC_CONST;
#define ANIMATE_TIMER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_ANIMATE_TIMER, AnimateTimerPrivate))
enum  {
	ANIMATE_TIMER_DUMMY_PROPERTY,
	ANIMATE_TIMER_SPEED,
	ANIMATE_TIMER_IS_RUNNING,
	ANIMATE_TIMER_PROGRESS
};
#define ANIMATE_TIMER_INSTANT 150
#define ANIMATE_TIMER_FAST 250
#define ANIMATE_TIMER_NORMAL 500
#define ANIMATE_TIMER_SLOW 1000
#define ANIMATE_TIMER_HALFWAY_VELOCITY 1.5708
#define ANIMATE_TIMER_HALFWAY_PROGRESS 0.75
AnimateTimer* animate_timer_new (gint speed);
AnimateTimer* animate_timer_construct (GType object_type, gint speed);
void animate_timer_reset (AnimateTimer* self, gint temp_speed);
void animate_timer_stop (AnimateTimer* self);
static gboolean animate_timer_animate_cb (AnimateTimer* self);
static gboolean _animate_timer_animate_cb_gsource_func (gpointer self);
gint animate_timer_get_speed (AnimateTimer* self);
gboolean animate_timer_extend (AnimateTimer* self, gdouble new_progress);
gdouble animate_timer_get_progress (AnimateTimer* self);
static gdouble animate_timer_calculate_progress (AnimateTimer* self, GTimeSpan time);
static void animate_timer_set_progress (AnimateTimer* self, gdouble value);
static gdouble animate_timer_normalize_time (AnimateTimer* self, GTimeSpan now);
static gdouble animate_timer_normalize_progress (AnimateTimer* self, gdouble p);
static gdouble animate_timer_easing_function (AnimateTimer* self, gdouble x);
void animate_timer_set_speed (AnimateTimer* self, gint value);
gboolean animate_timer_get_is_running (AnimateTimer* self);
static void animate_timer_finalize (GObject* obj);
static void _vala_animate_timer_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_animate_timer_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


AnimateTimer* animate_timer_construct (GType object_type, gint speed) {
	AnimateTimer * self = NULL;
	gint _tmp0_;
	_tmp0_ = speed;
	self = (AnimateTimer*) g_object_new (object_type, "speed", _tmp0_, NULL);
	return self;
}


AnimateTimer* animate_timer_new (gint speed) {
	return animate_timer_construct (TYPE_ANIMATE_TIMER, speed);
}


static gboolean _animate_timer_animate_cb_gsource_func (gpointer self) {
	gboolean result;
	result = animate_timer_animate_cb (self);
	return result;
}


void animate_timer_reset (AnimateTimer* self, gint temp_speed) {
	guint _tmp0_ = 0U;
	gint _tmp1_;
	gint _tmp3_;
	g_return_if_fail (self != NULL);
	animate_timer_stop (self);
	_tmp0_ = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 16, _animate_timer_animate_cb_gsource_func, g_object_ref (self), g_object_unref);
	self->priv->timeout = _tmp0_;
	self->priv->start_time = (GTimeSpan) 0;
	self->priv->extra_time = (GTimeSpan) 0;
	self->priv->extra_progress = (gdouble) 0;
	_tmp1_ = temp_speed;
	if (_tmp1_ == 0) {
		gint _tmp2_;
		_tmp2_ = self->priv->_speed;
		temp_speed = _tmp2_;
	}
	_tmp3_ = temp_speed;
	self->priv->length = _tmp3_ * G_TIME_SPAN_MILLISECOND;
}


gboolean animate_timer_extend (AnimateTimer* self, gdouble new_progress) {
	gboolean result = FALSE;
	gdouble _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
	GTimeSpan _tmp3_;
	gdouble _tmp4_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_progress;
	if (_tmp0_ > ANIMATE_TIMER_HALFWAY_PROGRESS) {
		result = FALSE;
		return result;
	}
	_tmp1_ = self->priv->extra_progress;
	_tmp2_ = new_progress;
	self->priv->extra_progress = _tmp1_ + _tmp2_;
	_tmp3_ = self->priv->length;
	_tmp4_ = self->priv->extra_progress;
	self->priv->extra_time = (GTimeSpan) ((_tmp3_ * _tmp4_) / ANIMATE_TIMER_HALFWAY_VELOCITY);
	result = TRUE;
	return result;
}


void animate_timer_stop (AnimateTimer* self) {
	guint _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->timeout;
	if (_tmp0_ != ((guint) 0)) {
		guint _tmp1_;
		_tmp1_ = self->priv->timeout;
		g_source_remove (_tmp1_);
	}
	self->priv->timeout = (guint) 0;
}


static gboolean animate_timer_animate_cb (AnimateTimer* self) {
	gboolean result = FALSE;
	GTimeSpan _tmp0_;
	gint64 _tmp2_ = 0LL;
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_;
	gdouble _tmp5_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->start_time;
	if (_tmp0_ == ((GTimeSpan) 0)) {
		gint64 _tmp1_ = 0LL;
		_tmp1_ = g_get_monotonic_time ();
		self->priv->start_time = (GTimeSpan) _tmp1_;
	}
	_tmp2_ = g_get_monotonic_time ();
	_tmp3_ = animate_timer_calculate_progress (self, (GTimeSpan) _tmp2_);
	animate_timer_set_progress (self, _tmp3_);
	_tmp4_ = self->priv->_progress;
	g_signal_emit_by_name (self, "animate", _tmp4_);
	_tmp5_ = self->priv->_progress;
	if (_tmp5_ >= 1.0) {
		self->priv->timeout = (guint) 0;
		result = FALSE;
		return result;
	} else {
		result = TRUE;
		return result;
	}
}


static gdouble animate_timer_normalize_time (AnimateTimer* self, GTimeSpan now) {
	gdouble result = 0.0;
	GTimeSpan _tmp0_;
	GTimeSpan total;
	GTimeSpan _tmp1_;
	GTimeSpan _tmp2_;
	GTimeSpan halfway;
	GTimeSpan _tmp3_;
	GTimeSpan _tmp4_;
	GTimeSpan _tmp7_;
	GTimeSpan _tmp8_;
	GTimeSpan _tmp9_;
	gdouble _tmp10_ = 0.0;
	g_return_val_if_fail (self != NULL, 0.0);
	_tmp0_ = self->priv->length;
	total = _tmp0_;
	_tmp1_ = self->priv->start_time;
	_tmp2_ = self->priv->length;
	halfway = _tmp1_ + (_tmp2_ / 2);
	_tmp3_ = now;
	_tmp4_ = halfway;
	if (_tmp3_ > _tmp4_) {
		GTimeSpan _tmp5_;
		GTimeSpan _tmp6_;
		_tmp5_ = now;
		_tmp6_ = self->priv->extra_time;
		now = _tmp5_ - _tmp6_;
	}
	_tmp7_ = now;
	_tmp8_ = self->priv->start_time;
	_tmp9_ = total;
	_tmp10_ = CLAMP (((gdouble) (_tmp7_ - _tmp8_)) / _tmp9_, 0.0, 1.0);
	result = _tmp10_;
	return result;
}


static gdouble animate_timer_normalize_progress (AnimateTimer* self, gdouble p) {
	gdouble result = 0.0;
	gdouble _tmp0_;
	gdouble _tmp1_;
	gdouble extra_mapped;
	gdouble _tmp2_;
	gdouble half_mapped;
	gdouble _tmp3_;
	g_return_val_if_fail (self != NULL, 0.0);
	_tmp0_ = self->priv->extra_progress;
	_tmp1_ = self->priv->extra_progress;
	extra_mapped = _tmp0_ / (1.0 + _tmp1_);
	_tmp2_ = self->priv->extra_progress;
	half_mapped = ANIMATE_TIMER_HALFWAY_PROGRESS / (1.0 + _tmp2_);
	_tmp3_ = p;
	if (_tmp3_ < ANIMATE_TIMER_HALFWAY_PROGRESS) {
		gdouble _tmp4_;
		gdouble _tmp5_;
		_tmp4_ = p;
		_tmp5_ = half_mapped;
		result = _tmp4_ * (_tmp5_ / ANIMATE_TIMER_HALFWAY_PROGRESS);
		return result;
	} else {
		gdouble _tmp6_;
		gdouble _tmp7_;
		gdouble end;
		gdouble _tmp8_;
		gdouble _tmp9_;
		gdouble _tmp10_;
		gdouble _tmp11_;
		_tmp6_ = half_mapped;
		_tmp7_ = extra_mapped;
		end = (1.0 - _tmp6_) - _tmp7_;
		_tmp8_ = p;
		_tmp9_ = end;
		_tmp10_ = half_mapped;
		_tmp11_ = extra_mapped;
		result = (((_tmp8_ - ANIMATE_TIMER_HALFWAY_PROGRESS) * (_tmp9_ / (1 - ANIMATE_TIMER_HALFWAY_PROGRESS))) + _tmp10_) + _tmp11_;
		return result;
	}
}


static gdouble animate_timer_calculate_progress (AnimateTimer* self, GTimeSpan time) {
	gdouble result = 0.0;
	gdouble y;
	GTimeSpan _tmp0_;
	GTimeSpan _tmp1_;
	GTimeSpan orig_half_point;
	GTimeSpan _tmp2_;
	GTimeSpan _tmp3_;
	GTimeSpan _tmp4_;
	GTimeSpan _tmp5_;
	gdouble _tmp29_;
	gdouble _tmp30_ = 0.0;
	g_return_val_if_fail (self != NULL, 0.0);
	y = 0.0;
	_tmp0_ = self->priv->start_time;
	_tmp1_ = self->priv->length;
	orig_half_point = _tmp0_ + (_tmp1_ / 2);
	_tmp2_ = time;
	_tmp3_ = self->priv->start_time;
	_tmp4_ = self->priv->length;
	_tmp5_ = self->priv->extra_time;
	if (_tmp2_ > ((_tmp3_ + _tmp4_) + _tmp5_)) {
		y = 1.0;
	} else {
		GTimeSpan _tmp6_;
		GTimeSpan _tmp7_;
		_tmp6_ = time;
		_tmp7_ = orig_half_point;
		if (_tmp6_ < _tmp7_) {
			GTimeSpan _tmp8_;
			gdouble _tmp9_ = 0.0;
			gdouble x;
			gdouble _tmp10_;
			gdouble _tmp11_ = 0.0;
			gdouble _tmp12_;
			gdouble _tmp13_ = 0.0;
			_tmp8_ = time;
			_tmp9_ = animate_timer_normalize_time (self, _tmp8_);
			x = _tmp9_;
			_tmp10_ = x;
			_tmp11_ = animate_timer_easing_function (self, _tmp10_);
			y = _tmp11_;
			_tmp12_ = y;
			_tmp13_ = animate_timer_normalize_progress (self, _tmp12_);
			y = _tmp13_;
		} else {
			GTimeSpan _tmp14_;
			GTimeSpan _tmp15_;
			GTimeSpan _tmp16_;
			_tmp14_ = time;
			_tmp15_ = orig_half_point;
			_tmp16_ = self->priv->extra_time;
			if (_tmp14_ < (_tmp15_ + _tmp16_)) {
				GTimeSpan _tmp17_;
				GTimeSpan _tmp18_;
				GTimeSpan _tmp19_;
				gdouble xpercent;
				gdouble _tmp20_;
				gdouble _tmp21_;
				gdouble _tmp22_;
				_tmp17_ = time;
				_tmp18_ = orig_half_point;
				_tmp19_ = self->priv->extra_time;
				xpercent = (_tmp17_ - _tmp18_) / ((gdouble) _tmp19_);
				_tmp20_ = xpercent;
				_tmp21_ = self->priv->extra_progress;
				_tmp22_ = self->priv->extra_progress;
				y = ((_tmp20_ * _tmp21_) + ANIMATE_TIMER_HALFWAY_PROGRESS) / (1.0 + _tmp22_);
			} else {
				GTimeSpan _tmp23_;
				gdouble _tmp24_ = 0.0;
				gdouble x;
				gdouble _tmp25_;
				gdouble _tmp26_ = 0.0;
				gdouble _tmp27_;
				gdouble _tmp28_ = 0.0;
				_tmp23_ = time;
				_tmp24_ = animate_timer_normalize_time (self, _tmp23_);
				x = _tmp24_;
				_tmp25_ = x;
				_tmp26_ = animate_timer_easing_function (self, _tmp25_);
				y = _tmp26_;
				_tmp27_ = y;
				_tmp28_ = animate_timer_normalize_progress (self, _tmp27_);
				y = _tmp28_;
			}
		}
	}
	_tmp29_ = y;
	_tmp30_ = CLAMP (_tmp29_, 0.0, 1.0);
	result = _tmp30_;
	return result;
}


static gdouble animate_timer_easing_function (AnimateTimer* self, gdouble x) {
	gdouble result = 0.0;
	gdouble _tmp0_;
	gdouble _tmp1_ = 0.0;
	gdouble y;
	gdouble _tmp2_;
	gdouble _tmp3_;
	gdouble _tmp4_;
	g_return_val_if_fail (self != NULL, 0.0);
	_tmp0_ = x;
	_tmp1_ = cos (G_PI * (1.0 - _tmp0_));
	y = (1 - _tmp1_) / 2;
	_tmp2_ = y;
	_tmp3_ = y;
	y = _tmp2_ * _tmp3_;
	_tmp4_ = y;
	y = 1.0 - _tmp4_;
	result = y;
	return result;
}


gint animate_timer_get_speed (AnimateTimer* self) {
	gint result;
	gint _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_speed;
	result = _tmp0_;
	return result;
}


void animate_timer_set_speed (AnimateTimer* self, gint value) {
	gint _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_speed = _tmp0_;
	g_object_notify ((GObject *) self, "speed");
}


gboolean animate_timer_get_is_running (AnimateTimer* self) {
	gboolean result;
	guint _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->timeout;
	result = _tmp0_ != ((guint) 0);
	return result;
}


gdouble animate_timer_get_progress (AnimateTimer* self) {
	gdouble result;
	gdouble _tmp0_;
	g_return_val_if_fail (self != NULL, 0.0);
	_tmp0_ = self->priv->_progress;
	result = _tmp0_;
	return result;
}


static void animate_timer_set_progress (AnimateTimer* self, gdouble value) {
	gdouble _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_progress = _tmp0_;
	g_object_notify ((GObject *) self, "progress");
}


static void animate_timer_class_init (AnimateTimerClass * klass) {
	animate_timer_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (AnimateTimerPrivate));
	G_OBJECT_CLASS (klass)->get_property = _vala_animate_timer_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_animate_timer_set_property;
	G_OBJECT_CLASS (klass)->finalize = animate_timer_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), ANIMATE_TIMER_SPEED, g_param_spec_int ("speed", "speed", "speed", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), ANIMATE_TIMER_IS_RUNNING, g_param_spec_boolean ("is-running", "is-running", "is-running", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), ANIMATE_TIMER_PROGRESS, g_param_spec_double ("progress", "progress", "progress", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_signal_new ("animate", TYPE_ANIMATE_TIMER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__DOUBLE, G_TYPE_NONE, 1, G_TYPE_DOUBLE);
}


static void animate_timer_instance_init (AnimateTimer * self) {
	self->priv = ANIMATE_TIMER_GET_PRIVATE (self);
	self->priv->timeout = (guint) 0;
	self->priv->start_time = (GTimeSpan) 0;
	self->priv->length = (GTimeSpan) 0;
	self->priv->extra_time = (GTimeSpan) 0;
	self->priv->extra_progress = 0.0;
}


static void animate_timer_finalize (GObject* obj) {
	AnimateTimer * self;
	self = ANIMATE_TIMER (obj);
	G_OBJECT_CLASS (animate_timer_parent_class)->finalize (obj);
}


GType animate_timer_get_type (void) {
	static volatile gsize animate_timer_type_id__volatile = 0;
	if (g_once_init_enter (&animate_timer_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (AnimateTimerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) animate_timer_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (AnimateTimer), 0, (GInstanceInitFunc) animate_timer_instance_init, NULL };
		GType animate_timer_type_id;
		animate_timer_type_id = g_type_register_static (G_TYPE_OBJECT, "AnimateTimer", &g_define_type_info, 0);
		g_once_init_leave (&animate_timer_type_id__volatile, animate_timer_type_id);
	}
	return animate_timer_type_id__volatile;
}


static void _vala_animate_timer_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	AnimateTimer * self;
	self = ANIMATE_TIMER (object);
	switch (property_id) {
		case ANIMATE_TIMER_SPEED:
		g_value_set_int (value, animate_timer_get_speed (self));
		break;
		case ANIMATE_TIMER_IS_RUNNING:
		g_value_set_boolean (value, animate_timer_get_is_running (self));
		break;
		case ANIMATE_TIMER_PROGRESS:
		g_value_set_double (value, animate_timer_get_progress (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_animate_timer_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	AnimateTimer * self;
	self = ANIMATE_TIMER (object);
	switch (property_id) {
		case ANIMATE_TIMER_SPEED:
		animate_timer_set_speed (self, g_value_get_int (value));
		break;
		case ANIMATE_TIMER_PROGRESS:
		animate_timer_set_progress (self, g_value_get_double (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



