/* background.c generated by valac 0.15.1, the Vala compiler
 * generated from background.vala, do not modify */

/* -*- Mode: Vala; indent-tabs-mode: nil; tab-width: 4 -*-
 *
 * Copyright (C) 2011,2012 Canonical Ltd
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 3 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authors: Robert Ancell <robert.ancell@canonical.com>
 *          Michael Terry <michael.terry@canonical.com>
 */

#include <glib.h>
#include <glib-object.h>
#include <cairo.h>
#include <stdlib.h>
#include <string.h>
#include <gdk/gdk.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <float.h>
#include <math.h>
#include <gtk/gtk.h>
#include <glib/gstdio.h>
#include <gobject/gvaluecollector.h>


#define TYPE_BACKGROUND_LOADER (background_loader_get_type ())
#define BACKGROUND_LOADER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BACKGROUND_LOADER, BackgroundLoader))
#define BACKGROUND_LOADER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BACKGROUND_LOADER, BackgroundLoaderClass))
#define IS_BACKGROUND_LOADER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BACKGROUND_LOADER))
#define IS_BACKGROUND_LOADER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BACKGROUND_LOADER))
#define BACKGROUND_LOADER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BACKGROUND_LOADER, BackgroundLoaderClass))

typedef struct _BackgroundLoader BackgroundLoader;
typedef struct _BackgroundLoaderClass BackgroundLoaderClass;
typedef struct _BackgroundLoaderPrivate BackgroundLoaderPrivate;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _cairo_surface_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_surface_destroy (var), NULL)))
#define _cairo_pattern_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_pattern_destroy (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _cairo_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_destroy (var), NULL)))
typedef struct _ParamSpecBackgroundLoader ParamSpecBackgroundLoader;

#define TYPE_BACKGROUND (background_get_type ())
#define BACKGROUND(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BACKGROUND, Background))
#define BACKGROUND_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BACKGROUND, BackgroundClass))
#define IS_BACKGROUND(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BACKGROUND))
#define IS_BACKGROUND_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BACKGROUND))
#define BACKGROUND_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BACKGROUND, BackgroundClass))

typedef struct _Background Background;
typedef struct _BackgroundClass BackgroundClass;
typedef struct _BackgroundPrivate BackgroundPrivate;

#define TYPE_ANIMATE_TIMER (animate_timer_get_type ())
#define ANIMATE_TIMER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ANIMATE_TIMER, AnimateTimer))
#define ANIMATE_TIMER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ANIMATE_TIMER, AnimateTimerClass))
#define IS_ANIMATE_TIMER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ANIMATE_TIMER))
#define IS_ANIMATE_TIMER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ANIMATE_TIMER))
#define ANIMATE_TIMER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ANIMATE_TIMER, AnimateTimerClass))

typedef struct _AnimateTimer AnimateTimer;
typedef struct _AnimateTimerClass AnimateTimerClass;

#define BACKGROUND_TYPE_DRAW_FLAGS (background_draw_flags_get_type ())
#define _background_loader_unref0(var) ((var == NULL) ? NULL : (var = (background_loader_unref (var), NULL)))
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))

struct _BackgroundLoader {
	GTypeInstance parent_instance;
	volatile int ref_count;
	BackgroundLoaderPrivate * priv;
	cairo_pattern_t* pattern;
};

struct _BackgroundLoaderClass {
	GTypeClass parent_class;
	void (*finalize) (BackgroundLoader *self);
};

struct _BackgroundLoaderPrivate {
	gchar* _filename;
	cairo_surface_t* _logo;
	gint width;
	gint height;
	gboolean draw_grid;
	GThread* thread;
	gboolean finished;
	guint ready_id;
};

struct _ParamSpecBackgroundLoader {
	GParamSpec parent_instance;
};

struct _Background {
	GtkBox parent_instance;
	BackgroundPrivate * priv;
};

struct _BackgroundClass {
	GtkBoxClass parent_class;
};

struct _BackgroundPrivate {
	gchar* _default_background;
	gchar* _current_background;
	gboolean _draw_grid;
	gdouble _alpha;
	AnimateTimer* timer;
	BackgroundLoader* current;
	BackgroundLoader* old;
	GHashTable* loaders;
	cairo_surface_t* logo_surface;
};

typedef enum  {
	BACKGROUND_DRAW_FLAGS_NONE,
	BACKGROUND_DRAW_FLAGS_GRID
} BackgroundDrawFlags;


static gpointer background_loader_parent_class = NULL;
static gpointer background_parent_class = NULL;

gpointer background_loader_ref (gpointer instance);
void background_loader_unref (gpointer instance);
GParamSpec* param_spec_background_loader (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_background_loader (GValue* value, gpointer v_object);
void value_take_background_loader (GValue* value, gpointer v_object);
gpointer value_get_background_loader (const GValue* value);
GType background_loader_get_type (void) G_GNUC_CONST;
#define BACKGROUND_LOADER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_BACKGROUND_LOADER, BackgroundLoaderPrivate))
enum  {
	BACKGROUND_LOADER_DUMMY_PROPERTY
};
BackgroundLoader* background_loader_new (const gchar* filename, gint width, gint height, gboolean draw_grid);
BackgroundLoader* background_loader_construct (GType object_type, const gchar* filename, gint width, gint height, gboolean draw_grid);
static void background_loader_set_filename (BackgroundLoader* self, const gchar* value);
gboolean background_loader_load (BackgroundLoader* self);
const gchar* background_loader_get_filename (BackgroundLoader* self);
static cairo_pattern_t* background_loader_render (BackgroundLoader* self);
static gpointer _background_loader_render_gthread_func (gpointer self);
static gboolean background_loader_ready_cb (BackgroundLoader* self);
static gboolean _background_loader_ready_cb_gsource_func (gpointer self);
gint get_grid_offset (gint size);
cairo_surface_t* background_loader_get_logo (BackgroundLoader* self);
#define grid_size 40
void background_loader_set_logo (BackgroundLoader* self, cairo_surface_t* value);
static void background_loader_finalize (BackgroundLoader* obj);
GType background_get_type (void) G_GNUC_CONST;
GType animate_timer_get_type (void) G_GNUC_CONST;
#define BACKGROUND_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_BACKGROUND, BackgroundPrivate))
enum  {
	BACKGROUND_DUMMY_PROPERTY,
	BACKGROUND_DEFAULT_BACKGROUND,
	BACKGROUND_CURRENT_BACKGROUND,
	BACKGROUND_DRAW_GRID,
	BACKGROUND_ALPHA
};
GType background_draw_flags_get_type (void) G_GNUC_CONST;
void background_set_logo (Background* self, const gchar* logo_path);
static void background_real_size_allocate (GtkWidget* base, GtkAllocation* allocation);
static BackgroundLoader* background_load_background (Background* self, const gchar* filename);
static void background_reload (Background* self);
static gboolean background_real_draw (GtkWidget* base, cairo_t* c);
gboolean background_get_draw_grid (Background* self);
void background_draw_full (Background* self, cairo_t* c, BackgroundDrawFlags flags);
gboolean animate_timer_get_is_running (AnimateTimer* self);
static void background_set_alpha (Background* self, gdouble value);
void animate_timer_reset (AnimateTimer* self, gint temp_speed);
gdouble background_get_alpha (Background* self);
static void background_overlay_grid (Background* self, cairo_t* c);
static void background_animate_cb (Background* self, gdouble progress);
const gchar* background_get_current_background (Background* self);
const gchar* background_get_default_background (Background* self);
static void ___lambda2_ (Background* self);
static void ____lambda2__background_loader_loaded (BackgroundLoader* _sender, gpointer self);
Background* background_new (void);
Background* background_construct (GType object_type);
void background_set_default_background (Background* self, const gchar* value);
void background_set_current_background (Background* self, const gchar* value);
void background_set_draw_grid (Background* self, gboolean value);
static GObject * background_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties);
#define ANIMATE_TIMER_INSTANT 150
AnimateTimer* animate_timer_new (gint speed);
AnimateTimer* animate_timer_construct (GType object_type, gint speed);
static void _background_animate_cb_animate_timer_animate (AnimateTimer* _sender, gdouble progress, gpointer self);
static void _g_free0_ (gpointer var);
static void _background_loader_unref0_ (gpointer var);
static void _background___lambda3_ (Background* self);
static void __background___lambda3__g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self);
static void background_finalize (GObject* obj);
static void _vala_background_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_background_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


BackgroundLoader* background_loader_construct (GType object_type, const gchar* filename, gint width, gint height, gboolean draw_grid) {
	BackgroundLoader* self = NULL;
	const gchar* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gboolean _tmp3_;
	g_return_val_if_fail (filename != NULL, NULL);
	self = (BackgroundLoader*) g_type_create_instance (object_type);
	_tmp0_ = filename;
	background_loader_set_filename (self, _tmp0_);
	_tmp1_ = width;
	self->priv->width = _tmp1_;
	_tmp2_ = height;
	self->priv->height = _tmp2_;
	_tmp3_ = draw_grid;
	self->priv->draw_grid = _tmp3_;
	return self;
}


BackgroundLoader* background_loader_new (const gchar* filename, gint width, gint height, gboolean draw_grid) {
	return background_loader_construct (TYPE_BACKGROUND_LOADER, filename, width, height, draw_grid);
}


static gpointer _background_loader_render_gthread_func (gpointer self) {
	gpointer result;
	result = background_loader_render (self);
	return result;
}


gboolean background_loader_load (BackgroundLoader* self) {
	gboolean result = FALSE;
	gboolean _tmp0_;
	GThread* _tmp1_;
	const gchar* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->finished;
	if (_tmp0_) {
		result = TRUE;
		return result;
	}
	_tmp1_ = self->priv->thread;
	if (_tmp1_ != NULL) {
		result = FALSE;
		return result;
	}
	_tmp2_ = self->priv->_filename;
	_tmp3_ = self->priv->width;
	_tmp4_ = self->priv->height;
	g_debug ("background.vala:55: Making background %s at %dx%d", _tmp2_, _tmp3_, _tmp4_);
	{
		GThread* _tmp5_ = NULL;
		GThread* _tmp6_;
		_tmp5_ = g_thread_create (_background_loader_render_gthread_func, self, TRUE, &_inner_error_);
		_tmp6_ = _tmp5_;
		if (_inner_error_ != NULL) {
			if (_inner_error_->domain == G_THREAD_ERROR) {
				goto __catch0_g_thread_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return FALSE;
		}
		self->priv->thread = _tmp6_;
	}
	goto __finally0;
	__catch0_g_thread_error:
	{
		GError* e = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		self->priv->finished = TRUE;
		result = TRUE;
		_g_error_free0 (e);
		return result;
	}
	__finally0:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return FALSE;
	}
	result = FALSE;
	return result;
}


static gboolean background_loader_ready_cb (BackgroundLoader* self) {
	gboolean result = FALSE;
	const gchar* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	GThread* _tmp3_;
	gpointer _tmp4_ = NULL;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_filename;
	_tmp1_ = self->priv->width;
	_tmp2_ = self->priv->height;
	g_debug ("background.vala:78: Render of background %s at %dx%d complete", _tmp0_, _tmp1_, _tmp2_);
	_tmp3_ = self->priv->thread;
	_tmp4_ = g_thread_join (_tmp3_);
	_cairo_pattern_destroy0 (self->pattern);
	self->pattern = (cairo_pattern_t*) _tmp4_;
	self->priv->thread = NULL;
	self->priv->finished = TRUE;
	g_signal_emit_by_name (self, "loaded");
	result = FALSE;
	return result;
}


static gboolean _background_loader_ready_cb_gsource_func (gpointer self) {
	gboolean result;
	result = background_loader_ready_cb (self);
	return result;
}


static cairo_pattern_t* background_loader_render (BackgroundLoader* self) {
	cairo_pattern_t* result = NULL;
	GdkColor color = {0};
	GdkPixbuf* orig_image;
	const gchar* _tmp0_;
	GdkColor _tmp1_ = {0};
	gboolean _tmp2_ = FALSE;
	GdkPixbuf* image;
	GdkPixbuf* _tmp9_;
	gint _tmp58_;
	gint _tmp59_ = 0;
	gint grid_x_offset;
	gint _tmp60_;
	gint _tmp61_ = 0;
	gint grid_y_offset;
	gint _tmp62_;
	gint _tmp63_;
	cairo_surface_t* _tmp64_;
	cairo_surface_t* surface;
	cairo_surface_t* _tmp65_;
	cairo_t* _tmp66_;
	cairo_t* bc;
	GdkPixbuf* _tmp67_;
	cairo_t* _tmp72_;
	cairo_surface_t* _tmp73_;
	cairo_surface_t* _tmp84_;
	cairo_pattern_t* _tmp85_;
	cairo_pattern_t* pattern;
	cairo_pattern_t* _tmp86_;
	guint _tmp87_ = 0U;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	orig_image = NULL;
	_tmp0_ = self->priv->_filename;
	_tmp2_ = gdk_color_parse (_tmp0_, &_tmp1_);
	color = _tmp1_;
	if (!_tmp2_) {
		{
			const gchar* _tmp3_;
			GdkPixbuf* _tmp4_;
			GdkPixbuf* _tmp5_;
			_tmp3_ = self->priv->_filename;
			_tmp4_ = gdk_pixbuf_new_from_file (_tmp3_, &_inner_error_);
			_tmp5_ = _tmp4_;
			if (_inner_error_ != NULL) {
				goto __catch1_g_error;
			}
			_g_object_unref0 (orig_image);
			orig_image = _tmp5_;
		}
		goto __finally1;
		__catch1_g_error:
		{
			GError* e = NULL;
			GError* _tmp6_;
			const gchar* _tmp7_;
			guint _tmp8_ = 0U;
			e = _inner_error_;
			_inner_error_ = NULL;
			_tmp6_ = e;
			_tmp7_ = _tmp6_->message;
			g_debug ("background.vala:101: Error loading background: %s", _tmp7_);
			_tmp8_ = gdk_threads_add_idle (_background_loader_ready_cb_gsource_func, self);
			self->priv->ready_id = _tmp8_;
			result = NULL;
			_g_error_free0 (e);
			_g_object_unref0 (orig_image);
			return result;
		}
		__finally1:
		if (_inner_error_ != NULL) {
			_g_object_unref0 (orig_image);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	}
	image = NULL;
	_tmp9_ = orig_image;
	if (_tmp9_ != NULL) {
		gint _tmp10_;
		gint _tmp11_;
		gdouble target_aspect;
		GdkPixbuf* _tmp12_;
		gint _tmp13_;
		gint _tmp14_;
		GdkPixbuf* _tmp15_;
		gint _tmp16_;
		gint _tmp17_;
		gdouble aspect;
		gdouble scale = 0.0;
		gdouble offset_x;
		gdouble offset_y;
		gdouble _tmp18_;
		gdouble _tmp19_;
		GdkPixbuf* _tmp38_;
		GdkColorspace _tmp39_;
		GdkColorspace _tmp40_;
		GdkPixbuf* _tmp41_;
		gboolean _tmp42_;
		gboolean _tmp43_;
		GdkPixbuf* _tmp44_;
		gint _tmp45_;
		gint _tmp46_;
		gint _tmp47_;
		gint _tmp48_;
		GdkPixbuf* _tmp49_;
		GdkPixbuf* _tmp50_;
		GdkPixbuf* _tmp51_;
		gint _tmp52_;
		gint _tmp53_;
		gdouble _tmp54_;
		gdouble _tmp55_;
		gdouble _tmp56_;
		gdouble _tmp57_;
		_tmp10_ = self->priv->width;
		_tmp11_ = self->priv->height;
		target_aspect = ((gdouble) _tmp10_) / _tmp11_;
		_tmp12_ = orig_image;
		_tmp13_ = gdk_pixbuf_get_width (_tmp12_);
		_tmp14_ = _tmp13_;
		_tmp15_ = orig_image;
		_tmp16_ = gdk_pixbuf_get_height (_tmp15_);
		_tmp17_ = _tmp16_;
		aspect = ((gdouble) _tmp14_) / _tmp17_;
		offset_x = (gdouble) 0;
		offset_y = (gdouble) 0;
		_tmp18_ = aspect;
		_tmp19_ = target_aspect;
		if (_tmp18_ > _tmp19_) {
			gint _tmp20_;
			GdkPixbuf* _tmp21_;
			gint _tmp22_;
			gint _tmp23_;
			GdkPixbuf* _tmp24_;
			gint _tmp25_;
			gint _tmp26_;
			gdouble _tmp27_;
			gint _tmp28_;
			_tmp20_ = self->priv->height;
			_tmp21_ = orig_image;
			_tmp22_ = gdk_pixbuf_get_height (_tmp21_);
			_tmp23_ = _tmp22_;
			scale = ((gdouble) _tmp20_) / _tmp23_;
			_tmp24_ = orig_image;
			_tmp25_ = gdk_pixbuf_get_width (_tmp24_);
			_tmp26_ = _tmp25_;
			_tmp27_ = scale;
			_tmp28_ = self->priv->width;
			offset_x = ((_tmp26_ * _tmp27_) - _tmp28_) / 2;
		} else {
			gint _tmp29_;
			GdkPixbuf* _tmp30_;
			gint _tmp31_;
			gint _tmp32_;
			GdkPixbuf* _tmp33_;
			gint _tmp34_;
			gint _tmp35_;
			gdouble _tmp36_;
			gint _tmp37_;
			_tmp29_ = self->priv->width;
			_tmp30_ = orig_image;
			_tmp31_ = gdk_pixbuf_get_width (_tmp30_);
			_tmp32_ = _tmp31_;
			scale = ((gdouble) _tmp29_) / _tmp32_;
			_tmp33_ = orig_image;
			_tmp34_ = gdk_pixbuf_get_height (_tmp33_);
			_tmp35_ = _tmp34_;
			_tmp36_ = scale;
			_tmp37_ = self->priv->height;
			offset_y = ((_tmp35_ * _tmp36_) - _tmp37_) / 2;
		}
		_tmp38_ = orig_image;
		_tmp39_ = gdk_pixbuf_get_colorspace (_tmp38_);
		_tmp40_ = _tmp39_;
		_tmp41_ = orig_image;
		_tmp42_ = gdk_pixbuf_get_has_alpha (_tmp41_);
		_tmp43_ = _tmp42_;
		_tmp44_ = orig_image;
		_tmp45_ = gdk_pixbuf_get_bits_per_sample (_tmp44_);
		_tmp46_ = _tmp45_;
		_tmp47_ = self->priv->width;
		_tmp48_ = self->priv->height;
		_tmp49_ = gdk_pixbuf_new (_tmp40_, _tmp43_, _tmp46_, _tmp47_, _tmp48_);
		_g_object_unref0 (image);
		image = _tmp49_;
		_tmp50_ = orig_image;
		_tmp51_ = image;
		_tmp52_ = self->priv->width;
		_tmp53_ = self->priv->height;
		_tmp54_ = offset_x;
		_tmp55_ = offset_y;
		_tmp56_ = scale;
		_tmp57_ = scale;
		gdk_pixbuf_scale (_tmp50_, _tmp51_, 0, 0, _tmp52_, _tmp53_, -_tmp54_, -_tmp55_, _tmp56_, _tmp57_, GDK_INTERP_BILINEAR);
	}
	_tmp58_ = self->priv->width;
	_tmp59_ = get_grid_offset (_tmp58_);
	grid_x_offset = _tmp59_;
	_tmp60_ = self->priv->height;
	_tmp61_ = get_grid_offset (_tmp60_);
	grid_y_offset = _tmp61_;
	_tmp62_ = self->priv->width;
	_tmp63_ = self->priv->height;
	_tmp64_ = cairo_image_surface_create (CAIRO_FORMAT_RGB24, _tmp62_, _tmp63_);
	surface = _tmp64_;
	_tmp65_ = surface;
	_tmp66_ = cairo_create (_tmp65_);
	bc = _tmp66_;
	_tmp67_ = image;
	if (_tmp67_ != NULL) {
		cairo_t* _tmp68_;
		GdkPixbuf* _tmp69_;
		_tmp68_ = bc;
		_tmp69_ = image;
		gdk_cairo_set_source_pixbuf (_tmp68_, _tmp69_, (gdouble) 0, (gdouble) 0);
	} else {
		cairo_t* _tmp70_;
		GdkColor _tmp71_;
		_tmp70_ = bc;
		_tmp71_ = color;
		gdk_cairo_set_source_color (_tmp70_, &_tmp71_);
	}
	_tmp72_ = bc;
	cairo_paint (_tmp72_);
	_tmp73_ = self->priv->_logo;
	if (_tmp73_ != NULL) {
		cairo_t* _tmp74_;
		gint _tmp75_;
		gint _tmp76_;
		gint y;
		cairo_t* _tmp77_;
		gint _tmp78_;
		gint _tmp79_;
		cairo_t* _tmp80_;
		cairo_surface_t* _tmp81_;
		cairo_t* _tmp82_;
		cairo_t* _tmp83_;
		_tmp74_ = bc;
		cairo_save (_tmp74_);
		_tmp75_ = self->priv->height;
		_tmp76_ = grid_y_offset;
		y = (((gint) ((_tmp75_ / grid_size) - 2)) * grid_size) + _tmp76_;
		_tmp77_ = bc;
		_tmp78_ = grid_x_offset;
		_tmp79_ = y;
		cairo_translate (_tmp77_, (gdouble) _tmp78_, (gdouble) _tmp79_);
		_tmp80_ = bc;
		_tmp81_ = self->priv->_logo;
		cairo_set_source_surface (_tmp80_, _tmp81_, (gdouble) 0, (gdouble) 0);
		_tmp82_ = bc;
		cairo_paint_with_alpha (_tmp82_, 0.5);
		_tmp83_ = bc;
		cairo_restore (_tmp83_);
	}
	_tmp84_ = surface;
	_tmp85_ = cairo_pattern_create_for_surface (_tmp84_);
	pattern = _tmp85_;
	_tmp86_ = pattern;
	cairo_pattern_set_extend (_tmp86_, CAIRO_EXTEND_REPEAT);
	_tmp87_ = gdk_threads_add_idle (_background_loader_ready_cb_gsource_func, self);
	self->priv->ready_id = _tmp87_;
	result = pattern;
	_cairo_destroy0 (bc);
	_cairo_surface_destroy0 (surface);
	_g_object_unref0 (image);
	_g_object_unref0 (orig_image);
	return result;
}


const gchar* background_loader_get_filename (BackgroundLoader* self) {
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_filename;
	result = _tmp0_;
	return result;
}


static void background_loader_set_filename (BackgroundLoader* self, const gchar* value) {
	const gchar* _tmp0_;
	gchar* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (self->priv->_filename);
	self->priv->_filename = _tmp1_;
}


cairo_surface_t* background_loader_get_logo (BackgroundLoader* self) {
	cairo_surface_t* result;
	cairo_surface_t* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_logo;
	result = _tmp0_;
	return result;
}


static gpointer _cairo_surface_reference0 (gpointer self) {
	return self ? cairo_surface_reference (self) : NULL;
}


void background_loader_set_logo (BackgroundLoader* self, cairo_surface_t* value) {
	cairo_surface_t* _tmp0_;
	cairo_surface_t* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = _cairo_surface_reference0 (_tmp0_);
	_cairo_surface_destroy0 (self->priv->_logo);
	self->priv->_logo = _tmp1_;
}


static void value_background_loader_init (GValue* value) {
	value->data[0].v_pointer = NULL;
}


static void value_background_loader_free_value (GValue* value) {
	if (value->data[0].v_pointer) {
		background_loader_unref (value->data[0].v_pointer);
	}
}


static void value_background_loader_copy_value (const GValue* src_value, GValue* dest_value) {
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = background_loader_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}


static gpointer value_background_loader_peek_pointer (const GValue* value) {
	return value->data[0].v_pointer;
}


static gchar* value_background_loader_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	if (collect_values[0].v_pointer) {
		BackgroundLoader* object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = background_loader_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}


static gchar* value_background_loader_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	BackgroundLoader** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = background_loader_ref (value->data[0].v_pointer);
	}
	return NULL;
}


GParamSpec* param_spec_background_loader (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	ParamSpecBackgroundLoader* spec;
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_BACKGROUND_LOADER), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}


gpointer value_get_background_loader (const GValue* value) {
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_BACKGROUND_LOADER), NULL);
	return value->data[0].v_pointer;
}


void value_set_background_loader (GValue* value, gpointer v_object) {
	BackgroundLoader* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_BACKGROUND_LOADER));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_BACKGROUND_LOADER));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		background_loader_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		background_loader_unref (old);
	}
}


void value_take_background_loader (GValue* value, gpointer v_object) {
	BackgroundLoader* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_BACKGROUND_LOADER));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_BACKGROUND_LOADER));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		background_loader_unref (old);
	}
}


static void background_loader_class_init (BackgroundLoaderClass * klass) {
	background_loader_parent_class = g_type_class_peek_parent (klass);
	BACKGROUND_LOADER_CLASS (klass)->finalize = background_loader_finalize;
	g_type_class_add_private (klass, sizeof (BackgroundLoaderPrivate));
	g_signal_new ("loaded", TYPE_BACKGROUND_LOADER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}


static void background_loader_instance_init (BackgroundLoader * self) {
	self->priv = BACKGROUND_LOADER_GET_PRIVATE (self);
	self->pattern = NULL;
	self->ref_count = 1;
}


static void background_loader_finalize (BackgroundLoader* obj) {
	BackgroundLoader * self;
	guint _tmp0_;
	self = BACKGROUND_LOADER (obj);
	_tmp0_ = self->priv->ready_id;
	if (_tmp0_ > ((guint) 0)) {
		guint _tmp1_;
		_tmp1_ = self->priv->ready_id;
		g_source_remove (_tmp1_);
	}
	self->priv->ready_id = (guint) 0;
	_g_free0 (self->priv->_filename);
	_cairo_surface_destroy0 (self->priv->_logo);
	_cairo_pattern_destroy0 (self->pattern);
}


GType background_loader_get_type (void) {
	static volatile gsize background_loader_type_id__volatile = 0;
	if (g_once_init_enter (&background_loader_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_background_loader_init, value_background_loader_free_value, value_background_loader_copy_value, value_background_loader_peek_pointer, "p", value_background_loader_collect_value, "p", value_background_loader_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (BackgroundLoaderClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) background_loader_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (BackgroundLoader), 0, (GInstanceInitFunc) background_loader_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType background_loader_type_id;
		background_loader_type_id = g_type_register_fundamental (g_type_fundamental_next (), "BackgroundLoader", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&background_loader_type_id__volatile, background_loader_type_id);
	}
	return background_loader_type_id__volatile;
}


gpointer background_loader_ref (gpointer instance) {
	BackgroundLoader* self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}


void background_loader_unref (gpointer instance) {
	BackgroundLoader* self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		BACKGROUND_LOADER_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}


GType background_draw_flags_get_type (void) {
	static volatile gsize background_draw_flags_type_id__volatile = 0;
	if (g_once_init_enter (&background_draw_flags_type_id__volatile)) {
		static const GEnumValue values[] = {{BACKGROUND_DRAW_FLAGS_NONE, "BACKGROUND_DRAW_FLAGS_NONE", "none"}, {BACKGROUND_DRAW_FLAGS_GRID, "BACKGROUND_DRAW_FLAGS_GRID", "grid"}, {0, NULL, NULL}};
		GType background_draw_flags_type_id;
		background_draw_flags_type_id = g_enum_register_static ("BackgroundDrawFlags", values);
		g_once_init_leave (&background_draw_flags_type_id__volatile, background_draw_flags_type_id);
	}
	return background_draw_flags_type_id__volatile;
}


void background_set_logo (Background* self, const gchar* logo_path) {
	const gchar* _tmp0_;
	gboolean _tmp1_ = FALSE;
	g_return_if_fail (self != NULL);
	g_return_if_fail (logo_path != NULL);
	_tmp0_ = logo_path;
	_tmp1_ = g_file_test (_tmp0_, G_FILE_TEST_EXISTS);
	if (_tmp1_) {
		const gchar* _tmp2_;
		cairo_surface_t* _tmp3_;
		_tmp2_ = logo_path;
		_tmp3_ = cairo_image_surface_create_from_png (_tmp2_);
		_cairo_surface_destroy0 (self->priv->logo_surface);
		self->priv->logo_surface = _tmp3_;
	} else {
		const gchar* _tmp4_;
		_tmp4_ = logo_path;
		g_debug ("background.vala:183: Can't use logo %s, it does not exist", _tmp4_);
		_cairo_surface_destroy0 (self->priv->logo_surface);
		self->priv->logo_surface = NULL;
	}
}


static void background_real_size_allocate (GtkWidget* base, GtkAllocation* allocation) {
	Background * self;
	gboolean _tmp0_ = FALSE;
	GtkAllocation _tmp1_;
	gint _tmp2_;
	gint _tmp3_ = 0;
	gboolean _tmp7_;
	gboolean resized;
	GtkAllocation _tmp8_;
	gboolean _tmp9_;
	self = (Background*) base;
	g_return_if_fail (allocation != NULL);
	_tmp1_ = *allocation;
	_tmp2_ = _tmp1_.height;
	_tmp3_ = gtk_widget_get_allocated_height ((GtkWidget*) self);
	if (_tmp2_ != _tmp3_) {
		_tmp0_ = TRUE;
	} else {
		GtkAllocation _tmp4_;
		gint _tmp5_;
		gint _tmp6_ = 0;
		_tmp4_ = *allocation;
		_tmp5_ = _tmp4_.width;
		_tmp6_ = gtk_widget_get_allocated_width ((GtkWidget*) self);
		_tmp0_ = _tmp5_ != _tmp6_;
	}
	_tmp7_ = _tmp0_;
	resized = _tmp7_;
	_tmp8_ = *allocation;
	GTK_WIDGET_CLASS (background_parent_class)->size_allocate ((GtkWidget*) GTK_BOX (self), &_tmp8_);
	_tmp9_ = resized;
	if (_tmp9_) {
		GHashTable* _tmp10_;
		BackgroundLoader* _tmp11_ = NULL;
		BackgroundLoader* _tmp12_;
		g_debug ("background.vala:197: Regenerating backgrounds");
		_tmp10_ = self->priv->loaders;
		g_hash_table_remove_all (_tmp10_);
		_tmp11_ = background_load_background (self, NULL);
		_tmp12_ = _tmp11_;
		_background_loader_unref0 (_tmp12_);
		background_reload (self);
	}
}


static gboolean background_real_draw (GtkWidget* base, cairo_t* c) {
	Background * self;
	gboolean result = FALSE;
	BackgroundDrawFlags flags;
	gboolean _tmp0_;
	cairo_t* _tmp2_;
	BackgroundDrawFlags _tmp3_;
	cairo_t* _tmp4_;
	gboolean _tmp5_ = FALSE;
	self = (Background*) base;
	g_return_val_if_fail (c != NULL, FALSE);
	flags = BACKGROUND_DRAW_FLAGS_NONE;
	_tmp0_ = self->priv->_draw_grid;
	if (_tmp0_) {
		BackgroundDrawFlags _tmp1_;
		_tmp1_ = flags;
		flags = _tmp1_ | BACKGROUND_DRAW_FLAGS_GRID;
	}
	_tmp2_ = c;
	_tmp3_ = flags;
	background_draw_full (self, _tmp2_, _tmp3_);
	_tmp4_ = c;
	_tmp5_ = GTK_WIDGET_CLASS (background_parent_class)->draw ((GtkWidget*) GTK_BOX (self), _tmp4_);
	result = _tmp5_;
	return result;
}


static gpointer _background_loader_ref0 (gpointer self) {
	return self ? background_loader_ref (self) : NULL;
}


void background_draw_full (Background* self, cairo_t* c, BackgroundDrawFlags flags) {
	cairo_t* _tmp0_;
	gboolean _tmp1_ = FALSE;
	BackgroundLoader* _tmp2_;
	gboolean _tmp9_;
	gboolean _tmp25_ = FALSE;
	gboolean _tmp26_ = FALSE;
	BackgroundLoader* _tmp27_;
	gboolean _tmp28_ = FALSE;
	gboolean _tmp31_;
	gboolean _tmp35_;
	cairo_t* _tmp37_;
	gboolean old_painted;
	gboolean _tmp38_ = FALSE;
	gboolean _tmp39_ = FALSE;
	BackgroundLoader* _tmp40_;
	gboolean _tmp43_;
	gboolean _tmp49_;
	gboolean _tmp54_ = FALSE;
	BackgroundLoader* _tmp55_;
	gboolean _tmp56_ = FALSE;
	gboolean _tmp58_;
	cairo_t* _tmp67_;
	BackgroundDrawFlags _tmp68_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (c != NULL);
	_tmp0_ = c;
	cairo_save (_tmp0_);
	_tmp2_ = self->priv->current;
	if (_tmp2_ == NULL) {
		_tmp1_ = TRUE;
	} else {
		gboolean _tmp3_ = FALSE;
		BackgroundLoader* _tmp4_;
		gboolean _tmp5_ = FALSE;
		gboolean _tmp8_;
		_tmp4_ = self->priv->current;
		_tmp5_ = background_loader_load (_tmp4_);
		if (_tmp5_) {
			BackgroundLoader* _tmp6_;
			cairo_pattern_t* _tmp7_;
			_tmp6_ = self->priv->current;
			_tmp7_ = _tmp6_->pattern;
			_tmp3_ = _tmp7_ == NULL;
		} else {
			_tmp3_ = FALSE;
		}
		_tmp8_ = _tmp3_;
		_tmp1_ = _tmp8_;
	}
	_tmp9_ = _tmp1_;
	if (_tmp9_) {
		BackgroundLoader* _tmp10_ = NULL;
		BackgroundLoader* new_background;
		BackgroundLoader* _tmp11_;
		BackgroundLoader* _tmp19_;
		BackgroundLoader* _tmp20_;
		BackgroundLoader* _tmp23_;
		BackgroundLoader* _tmp24_;
		_tmp10_ = background_load_background (self, NULL);
		new_background = _tmp10_;
		_tmp11_ = self->priv->current;
		if (_tmp11_ != NULL) {
			GHashTable* _tmp12_;
			BackgroundLoader* _tmp13_;
			const gchar* _tmp14_;
			const gchar* _tmp15_;
			gchar* _tmp16_;
			BackgroundLoader* _tmp17_;
			BackgroundLoader* _tmp18_;
			_tmp12_ = self->priv->loaders;
			_tmp13_ = self->priv->current;
			_tmp14_ = background_loader_get_filename (_tmp13_);
			_tmp15_ = _tmp14_;
			_tmp16_ = g_strdup (_tmp15_);
			_tmp17_ = new_background;
			_tmp18_ = _background_loader_ref0 (_tmp17_);
			g_hash_table_insert (_tmp12_, _tmp16_, _tmp18_);
		}
		_tmp19_ = self->priv->old;
		_tmp20_ = self->priv->current;
		if (_tmp19_ == _tmp20_) {
			BackgroundLoader* _tmp21_;
			BackgroundLoader* _tmp22_;
			_tmp21_ = new_background;
			_tmp22_ = _background_loader_ref0 (_tmp21_);
			_background_loader_unref0 (self->priv->old);
			self->priv->old = _tmp22_;
		}
		_tmp23_ = new_background;
		_tmp24_ = _background_loader_ref0 (_tmp23_);
		_background_loader_unref0 (self->priv->current);
		self->priv->current = _tmp24_;
		_background_loader_unref0 (new_background);
	}
	_tmp27_ = self->priv->current;
	_tmp28_ = background_loader_load (_tmp27_);
	if (_tmp28_) {
		BackgroundLoader* _tmp29_;
		BackgroundLoader* _tmp30_;
		_tmp29_ = self->priv->current;
		_tmp30_ = self->priv->old;
		_tmp26_ = _tmp29_ != _tmp30_;
	} else {
		_tmp26_ = FALSE;
	}
	_tmp31_ = _tmp26_;
	if (_tmp31_) {
		AnimateTimer* _tmp32_;
		gboolean _tmp33_;
		gboolean _tmp34_;
		_tmp32_ = self->priv->timer;
		_tmp33_ = animate_timer_get_is_running (_tmp32_);
		_tmp34_ = _tmp33_;
		_tmp25_ = !_tmp34_;
	} else {
		_tmp25_ = FALSE;
	}
	_tmp35_ = _tmp25_;
	if (_tmp35_) {
		AnimateTimer* _tmp36_;
		background_set_alpha (self, 0.0);
		_tmp36_ = self->priv->timer;
		animate_timer_reset (_tmp36_, 0);
	}
	_tmp37_ = c;
	cairo_set_source_rgba (_tmp37_, 0.0, 0.0, 0.0, 0.0);
	old_painted = FALSE;
	_tmp40_ = self->priv->old;
	if (_tmp40_ != NULL) {
		BackgroundLoader* _tmp41_;
		gboolean _tmp42_ = FALSE;
		_tmp41_ = self->priv->old;
		_tmp42_ = background_loader_load (_tmp41_);
		_tmp39_ = _tmp42_;
	} else {
		_tmp39_ = FALSE;
	}
	_tmp43_ = _tmp39_;
	if (_tmp43_) {
		gboolean _tmp44_ = FALSE;
		gdouble _tmp45_;
		gboolean _tmp48_;
		_tmp45_ = self->priv->_alpha;
		if (_tmp45_ < 1.0) {
			_tmp44_ = TRUE;
		} else {
			BackgroundLoader* _tmp46_;
			gboolean _tmp47_ = FALSE;
			_tmp46_ = self->priv->current;
			_tmp47_ = background_loader_load (_tmp46_);
			_tmp44_ = !_tmp47_;
		}
		_tmp48_ = _tmp44_;
		_tmp38_ = _tmp48_;
	} else {
		_tmp38_ = FALSE;
	}
	_tmp49_ = _tmp38_;
	if (_tmp49_) {
		cairo_t* _tmp50_;
		BackgroundLoader* _tmp51_;
		cairo_pattern_t* _tmp52_;
		cairo_t* _tmp53_;
		_tmp50_ = c;
		_tmp51_ = self->priv->old;
		_tmp52_ = _tmp51_->pattern;
		cairo_set_source (_tmp50_, _tmp52_);
		_tmp53_ = c;
		cairo_paint (_tmp53_);
		old_painted = TRUE;
	}
	_tmp55_ = self->priv->current;
	_tmp56_ = background_loader_load (_tmp55_);
	if (_tmp56_) {
		gdouble _tmp57_;
		_tmp57_ = self->priv->_alpha;
		_tmp54_ = _tmp57_ > 0.0;
	} else {
		_tmp54_ = FALSE;
	}
	_tmp58_ = _tmp54_;
	if (_tmp58_) {
		cairo_t* _tmp59_;
		BackgroundLoader* _tmp60_;
		cairo_pattern_t* _tmp61_;
		gdouble _tmp62_ = 0.0;
		gboolean _tmp63_;
		cairo_t* _tmp65_;
		gdouble _tmp66_;
		_tmp59_ = c;
		_tmp60_ = self->priv->current;
		_tmp61_ = _tmp60_->pattern;
		cairo_set_source (_tmp59_, _tmp61_);
		_tmp63_ = old_painted;
		if (_tmp63_) {
			gdouble _tmp64_;
			_tmp64_ = self->priv->_alpha;
			_tmp62_ = _tmp64_;
		} else {
			_tmp62_ = 1.0;
		}
		_tmp65_ = c;
		_tmp66_ = _tmp62_;
		cairo_paint_with_alpha (_tmp65_, _tmp66_);
	}
	_tmp67_ = c;
	cairo_restore (_tmp67_);
	_tmp68_ = flags;
	if ((_tmp68_ & BACKGROUND_DRAW_FLAGS_GRID) != 0) {
		cairo_t* _tmp69_;
		_tmp69_ = c;
		background_overlay_grid (self, _tmp69_);
	}
}


static void background_animate_cb (Background* self, gdouble progress) {
	gdouble _tmp0_;
	gdouble _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = progress;
	background_set_alpha (self, _tmp0_);
	gtk_widget_queue_draw ((GtkWidget*) self);
	_tmp1_ = self->priv->_alpha;
	if (_tmp1_ >= 1.0) {
		BackgroundLoader* _tmp2_;
		BackgroundLoader* _tmp3_;
		_tmp2_ = self->priv->current;
		_tmp3_ = _background_loader_ref0 (_tmp2_);
		_background_loader_unref0 (self->priv->old);
		self->priv->old = _tmp3_;
	}
}


static void background_reload (Background* self) {
	gboolean _tmp0_ = FALSE;
	g_return_if_fail (self != NULL);
	_tmp0_ = gtk_widget_get_realized ((GtkWidget*) self);
	if (_tmp0_) {
		const gchar* _tmp1_;
		BackgroundLoader* _tmp2_ = NULL;
		BackgroundLoader* new_background;
		BackgroundLoader* _tmp3_;
		BackgroundLoader* _tmp4_;
		_tmp1_ = self->priv->_current_background;
		_tmp2_ = background_load_background (self, _tmp1_);
		new_background = _tmp2_;
		_tmp3_ = self->priv->current;
		_tmp4_ = new_background;
		if (_tmp3_ != _tmp4_) {
			BackgroundLoader* _tmp5_;
			BackgroundLoader* _tmp6_;
			BackgroundLoader* _tmp7_;
			BackgroundLoader* _tmp8_;
			_tmp5_ = self->priv->current;
			_tmp6_ = _background_loader_ref0 (_tmp5_);
			_background_loader_unref0 (self->priv->old);
			self->priv->old = _tmp6_;
			_tmp7_ = new_background;
			_tmp8_ = _background_loader_ref0 (_tmp7_);
			_background_loader_unref0 (self->priv->current);
			self->priv->current = _tmp8_;
		}
		gtk_widget_queue_draw ((GtkWidget*) self);
		_background_loader_unref0 (new_background);
	}
}


static void ___lambda2_ (Background* self) {
	background_reload (self);
}


static void ____lambda2__background_loader_loaded (BackgroundLoader* _sender, gpointer self) {
	___lambda2_ (self);
}


static BackgroundLoader* background_load_background (Background* self, const gchar* filename) {
	BackgroundLoader* result = NULL;
	const gchar* _tmp0_;
	GHashTable* _tmp2_;
	const gchar* _tmp3_;
	gconstpointer _tmp4_ = NULL;
	BackgroundLoader* _tmp5_;
	BackgroundLoader* b;
	BackgroundLoader* _tmp6_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = filename;
	if (_tmp0_ == NULL) {
		const gchar* _tmp1_;
		_tmp1_ = self->priv->_default_background;
		filename = _tmp1_;
	}
	_tmp2_ = self->priv->loaders;
	_tmp3_ = filename;
	_tmp4_ = g_hash_table_lookup (_tmp2_, _tmp3_);
	_tmp5_ = _background_loader_ref0 ((BackgroundLoader*) _tmp4_);
	b = _tmp5_;
	_tmp6_ = b;
	if (_tmp6_ == NULL) {
		const gchar* _tmp7_;
		gint _tmp8_ = 0;
		gint _tmp9_ = 0;
		gboolean _tmp10_;
		BackgroundLoader* _tmp11_;
		BackgroundLoader* _tmp12_;
		cairo_surface_t* _tmp13_;
		BackgroundLoader* _tmp14_;
		BackgroundLoader* _tmp15_;
		GHashTable* _tmp16_;
		const gchar* _tmp17_;
		gchar* _tmp18_;
		BackgroundLoader* _tmp19_;
		BackgroundLoader* _tmp20_;
		_tmp7_ = filename;
		_tmp8_ = gtk_widget_get_allocated_width ((GtkWidget*) self);
		_tmp9_ = gtk_widget_get_allocated_height ((GtkWidget*) self);
		_tmp10_ = self->priv->_draw_grid;
		_tmp11_ = background_loader_new (_tmp7_, _tmp8_, _tmp9_, _tmp10_);
		_background_loader_unref0 (b);
		b = _tmp11_;
		_tmp12_ = b;
		_tmp13_ = self->priv->logo_surface;
		background_loader_set_logo (_tmp12_, _tmp13_);
		_tmp14_ = b;
		g_signal_connect_object (_tmp14_, "loaded", (GCallback) ____lambda2__background_loader_loaded, self, 0);
		_tmp15_ = b;
		background_loader_load (_tmp15_);
		_tmp16_ = self->priv->loaders;
		_tmp17_ = filename;
		_tmp18_ = g_strdup (_tmp17_);
		_tmp19_ = b;
		_tmp20_ = _background_loader_ref0 (_tmp19_);
		g_hash_table_insert (_tmp16_, _tmp18_, _tmp20_);
	}
	result = b;
	return result;
}


static void background_overlay_grid (Background* self, cairo_t* c) {
	gint _tmp0_ = 0;
	gint width;
	gint _tmp1_ = 0;
	gint height;
	gint _tmp2_ = 0;
	gint grid_x_offset;
	gint _tmp3_ = 0;
	gint grid_y_offset;
	cairo_surface_t* _tmp4_;
	cairo_surface_t* overlay_surface;
	cairo_t* _tmp5_;
	cairo_t* oc;
	cairo_pattern_t* _tmp6_;
	cairo_pattern_t* overlay;
	cairo_matrix_t matrix = {0};
	cairo_matrix_t _tmp7_;
	cairo_t* _tmp8_;
	cairo_t* _tmp9_;
	cairo_t* _tmp10_;
	cairo_t* _tmp11_;
	cairo_t* _tmp12_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (c != NULL);
	_tmp0_ = gtk_widget_get_allocated_width ((GtkWidget*) self);
	width = _tmp0_;
	_tmp1_ = gtk_widget_get_allocated_height ((GtkWidget*) self);
	height = _tmp1_;
	_tmp2_ = get_grid_offset (width);
	grid_x_offset = _tmp2_;
	_tmp3_ = get_grid_offset (height);
	grid_y_offset = _tmp3_;
	_tmp4_ = cairo_image_surface_create (CAIRO_FORMAT_ARGB32, grid_size, grid_size);
	overlay_surface = _tmp4_;
	_tmp5_ = cairo_create (overlay_surface);
	oc = _tmp5_;
	cairo_rectangle (oc, (gdouble) 0, (gdouble) 0, (gdouble) 1, (gdouble) 1);
	cairo_rectangle (oc, (gdouble) (grid_size - 1), (gdouble) 0, (gdouble) 1, (gdouble) 1);
	cairo_rectangle (oc, (gdouble) 0, (gdouble) (grid_size - 1), (gdouble) 1, (gdouble) 1);
	cairo_rectangle (oc, (gdouble) (grid_size - 1), (gdouble) (grid_size - 1), (gdouble) 1, (gdouble) 1);
	cairo_set_source_rgba (oc, 1.0, 1.0, 1.0, 0.25);
	cairo_fill (oc);
	_tmp6_ = cairo_pattern_create_for_surface (overlay_surface);
	overlay = _tmp6_;
	cairo_matrix_init_identity (&matrix);
	cairo_matrix_translate (&matrix, (gdouble) (-grid_x_offset), (gdouble) (-grid_y_offset));
	_tmp7_ = matrix;
	cairo_pattern_set_matrix (overlay, &_tmp7_);
	cairo_pattern_set_extend (overlay, CAIRO_EXTEND_REPEAT);
	_tmp8_ = c;
	cairo_save (_tmp8_);
	_tmp9_ = c;
	cairo_set_source (_tmp9_, overlay);
	_tmp10_ = c;
	cairo_rectangle (_tmp10_, (gdouble) 0, (gdouble) 0, (gdouble) width, (gdouble) height);
	_tmp11_ = c;
	cairo_fill (_tmp11_);
	_tmp12_ = c;
	cairo_restore (_tmp12_);
	_cairo_pattern_destroy0 (overlay);
	_cairo_destroy0 (oc);
	_cairo_surface_destroy0 (overlay_surface);
}


Background* background_construct (GType object_type) {
	Background * self = NULL;
	self = (Background*) g_object_new (object_type, NULL);
	return self;
}


Background* background_new (void) {
	return background_construct (TYPE_BACKGROUND);
}


const gchar* background_get_default_background (Background* self) {
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_default_background;
	result = _tmp0_;
	return result;
}


void background_set_default_background (Background* self, const gchar* value) {
	const gchar* _tmp0_;
	gchar* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (self->priv->_default_background);
	self->priv->_default_background = _tmp1_;
	g_object_notify ((GObject *) self, "default-background");
}


const gchar* background_get_current_background (Background* self) {
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_current_background;
	result = _tmp0_;
	return result;
}


void background_set_current_background (Background* self, const gchar* value) {
	const gchar* _tmp0_;
	gchar* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (self->priv->_current_background);
	self->priv->_current_background = _tmp1_;
	g_object_notify ((GObject *) self, "current-background");
}


gboolean background_get_draw_grid (Background* self) {
	gboolean result;
	gboolean _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_draw_grid;
	result = _tmp0_;
	return result;
}


void background_set_draw_grid (Background* self, gboolean value) {
	gboolean _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_draw_grid = _tmp0_;
	g_object_notify ((GObject *) self, "draw-grid");
}


gdouble background_get_alpha (Background* self) {
	gdouble result;
	gdouble _tmp0_;
	g_return_val_if_fail (self != NULL, 0.0);
	_tmp0_ = self->priv->_alpha;
	result = _tmp0_;
	return result;
}


static void background_set_alpha (Background* self, gdouble value) {
	gdouble _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_alpha = _tmp0_;
	g_object_notify ((GObject *) self, "alpha");
}


static void _background_animate_cb_animate_timer_animate (AnimateTimer* _sender, gdouble progress, gpointer self) {
	background_animate_cb (self, progress);
}


static void _g_free0_ (gpointer var) {
	var = (g_free (var), NULL);
}


static void _background_loader_unref0_ (gpointer var) {
	(var == NULL) ? NULL : (var = (background_loader_unref (var), NULL));
}


static void _background___lambda3_ (Background* self) {
	background_reload (self);
}


static void __background___lambda3__g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self) {
	_background___lambda3_ (self);
}


static GObject * background_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties) {
	GObject * obj;
	GObjectClass * parent_class;
	Background * self;
	AnimateTimer* _tmp0_;
	AnimateTimer* _tmp1_;
	GHashFunc _tmp2_;
	GEqualFunc _tmp3_;
	GHashTable* _tmp4_;
	parent_class = G_OBJECT_CLASS (background_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = BACKGROUND (obj);
	gtk_orientable_set_orientation ((GtkOrientable*) self, GTK_ORIENTATION_VERTICAL);
	_tmp0_ = animate_timer_new (ANIMATE_TIMER_INSTANT);
	_g_object_unref0 (self->priv->timer);
	self->priv->timer = _tmp0_;
	_tmp1_ = self->priv->timer;
	g_signal_connect_object (_tmp1_, "animate", (GCallback) _background_animate_cb_animate_timer_animate, self, 0);
	_tmp2_ = g_str_hash;
	_tmp3_ = g_str_equal;
	_tmp4_ = g_hash_table_new_full (_tmp2_, _tmp3_, _g_free0_, _background_loader_unref0_);
	_g_hash_table_unref0 (self->priv->loaders);
	self->priv->loaders = _tmp4_;
	g_signal_connect_object ((GObject*) self, "notify::current-background", (GCallback) __background___lambda3__g_object_notify, self, 0);
	return obj;
}


static void background_class_init (BackgroundClass * klass) {
	background_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (BackgroundPrivate));
	GTK_WIDGET_CLASS (klass)->size_allocate = background_real_size_allocate;
	GTK_WIDGET_CLASS (klass)->draw = background_real_draw;
	G_OBJECT_CLASS (klass)->get_property = _vala_background_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_background_set_property;
	G_OBJECT_CLASS (klass)->constructor = background_constructor;
	G_OBJECT_CLASS (klass)->finalize = background_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), BACKGROUND_DEFAULT_BACKGROUND, g_param_spec_string ("default-background", "default-background", "default-background", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), BACKGROUND_CURRENT_BACKGROUND, g_param_spec_string ("current-background", "current-background", "current-background", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), BACKGROUND_DRAW_GRID, g_param_spec_boolean ("draw-grid", "draw-grid", "draw-grid", TRUE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), BACKGROUND_ALPHA, g_param_spec_double ("alpha", "alpha", "alpha", -G_MAXDOUBLE, G_MAXDOUBLE, 1.0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
}


static void background_instance_init (Background * self) {
	gchar* _tmp0_;
	self->priv = BACKGROUND_GET_PRIVATE (self);
	_tmp0_ = g_strdup ("#2C001E");
	self->priv->_default_background = _tmp0_;
	self->priv->_current_background = NULL;
	self->priv->_draw_grid = TRUE;
	self->priv->_alpha = 1.0;
	self->priv->logo_surface = NULL;
}


static void background_finalize (GObject* obj) {
	Background * self;
	self = BACKGROUND (obj);
	_g_free0 (self->priv->_default_background);
	_g_free0 (self->priv->_current_background);
	_g_object_unref0 (self->priv->timer);
	_background_loader_unref0 (self->priv->current);
	_background_loader_unref0 (self->priv->old);
	_g_hash_table_unref0 (self->priv->loaders);
	_cairo_surface_destroy0 (self->priv->logo_surface);
	G_OBJECT_CLASS (background_parent_class)->finalize (obj);
}


GType background_get_type (void) {
	static volatile gsize background_type_id__volatile = 0;
	if (g_once_init_enter (&background_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (BackgroundClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) background_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Background), 0, (GInstanceInitFunc) background_instance_init, NULL };
		GType background_type_id;
		background_type_id = g_type_register_static (GTK_TYPE_BOX, "Background", &g_define_type_info, 0);
		g_once_init_leave (&background_type_id__volatile, background_type_id);
	}
	return background_type_id__volatile;
}


static void _vala_background_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	Background * self;
	self = BACKGROUND (object);
	switch (property_id) {
		case BACKGROUND_DEFAULT_BACKGROUND:
		g_value_set_string (value, background_get_default_background (self));
		break;
		case BACKGROUND_CURRENT_BACKGROUND:
		g_value_set_string (value, background_get_current_background (self));
		break;
		case BACKGROUND_DRAW_GRID:
		g_value_set_boolean (value, background_get_draw_grid (self));
		break;
		case BACKGROUND_ALPHA:
		g_value_set_double (value, background_get_alpha (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_background_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	Background * self;
	self = BACKGROUND (object);
	switch (property_id) {
		case BACKGROUND_DEFAULT_BACKGROUND:
		background_set_default_background (self, g_value_get_string (value));
		break;
		case BACKGROUND_CURRENT_BACKGROUND:
		background_set_current_background (self, g_value_get_string (value));
		break;
		case BACKGROUND_DRAW_GRID:
		background_set_draw_grid (self, g_value_get_boolean (value));
		break;
		case BACKGROUND_ALPHA:
		background_set_alpha (self, g_value_get_double (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



