/* dash-button.c generated by valac 0.15.1, the Vala compiler
 * generated from dash-button.vala, do not modify */

/* -*- Mode: Vala; indent-tabs-mode: nil; tab-width: 4 -*-
 *
 * Copyright (C) 2012 Canonical Ltd
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 3 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authors: Michael Terry <michael.terry@canonical.com>
 */

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <cairo.h>
#include <float.h>
#include <math.h>


#define TYPE_FADABLE (fadable_get_type ())
#define FADABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_FADABLE, Fadable))
#define IS_FADABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_FADABLE))
#define FADABLE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_FADABLE, FadableIface))

typedef struct _Fadable Fadable;
typedef struct _FadableIface FadableIface;

#define TYPE_FADE_TRACKER (fade_tracker_get_type ())
#define FADE_TRACKER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_FADE_TRACKER, FadeTracker))
#define FADE_TRACKER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_FADE_TRACKER, FadeTrackerClass))
#define IS_FADE_TRACKER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_FADE_TRACKER))
#define IS_FADE_TRACKER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_FADE_TRACKER))
#define FADE_TRACKER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_FADE_TRACKER, FadeTrackerClass))

typedef struct _FadeTracker FadeTracker;
typedef struct _FadeTrackerClass FadeTrackerClass;

#define TYPE_DASH_BUTTON (dash_button_get_type ())
#define DASH_BUTTON(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DASH_BUTTON, DashButton))
#define DASH_BUTTON_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DASH_BUTTON, DashButtonClass))
#define IS_DASH_BUTTON(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DASH_BUTTON))
#define IS_DASH_BUTTON_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DASH_BUTTON))
#define DASH_BUTTON_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DASH_BUTTON, DashButtonClass))

typedef struct _DashButton DashButton;
typedef struct _DashButtonClass DashButtonClass;
typedef struct _DashButtonPrivate DashButtonPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _FadableIface {
	GTypeInterface parent_iface;
	FadeTracker* (*get_fade_tracker) (Fadable* self);
	void (*set_fade_tracker) (Fadable* self, FadeTracker* value);
};

struct _DashButton {
	GtkButton parent_instance;
	DashButtonPrivate * priv;
};

struct _DashButtonClass {
	GtkButtonClass parent_class;
};

struct _DashButtonPrivate {
	FadeTracker* _fade_tracker;
};


static gpointer dash_button_parent_class = NULL;
static FadableIface* dash_button_fadable_parent_iface = NULL;

GType fade_tracker_get_type (void) G_GNUC_CONST;
GType fadable_get_type (void) G_GNUC_CONST;
GType dash_button_get_type (void) G_GNUC_CONST;
#define DASH_BUTTON_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_DASH_BUTTON, DashButtonPrivate))
enum  {
	DASH_BUTTON_DUMMY_PROPERTY,
	DASH_BUTTON_FADE_TRACKER
};
static gboolean dash_button_real_draw (GtkWidget* base, cairo_t* c);
FadeTracker* fadable_get_fade_tracker (Fadable* self);
gdouble fade_tracker_get_alpha (FadeTracker* self);
DashButton* dash_button_new (void);
DashButton* dash_button_construct (GType object_type);
static GObject * dash_button_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties);
FadeTracker* fade_tracker_new (GtkWidget* widget);
FadeTracker* fade_tracker_construct (GType object_type, GtkWidget* widget);
void fadable_set_fade_tracker (Fadable* self, FadeTracker* value);
static void dash_button_finalize (GObject* obj);
static void _vala_dash_button_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_dash_button_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


static gboolean dash_button_real_draw (GtkWidget* base, cairo_t* c) {
	DashButton * self;
	gboolean result = FALSE;
	cairo_t* _tmp0_;
	cairo_t* _tmp1_;
	cairo_t* _tmp2_;
	cairo_t* _tmp3_;
	FadeTracker* _tmp4_;
	FadeTracker* _tmp5_;
	gdouble _tmp6_;
	gdouble _tmp7_;
	self = (DashButton*) base;
	g_return_val_if_fail (c != NULL, FALSE);
	_tmp0_ = c;
	cairo_push_group (_tmp0_);
	_tmp1_ = c;
	GTK_WIDGET_CLASS (dash_button_parent_class)->draw ((GtkWidget*) GTK_BUTTON (self), _tmp1_);
	_tmp2_ = c;
	cairo_pop_group_to_source (_tmp2_);
	_tmp3_ = c;
	_tmp4_ = fadable_get_fade_tracker ((Fadable*) self);
	_tmp5_ = _tmp4_;
	_tmp6_ = fade_tracker_get_alpha (_tmp5_);
	_tmp7_ = _tmp6_;
	cairo_paint_with_alpha (_tmp3_, _tmp7_);
	result = FALSE;
	return result;
}


DashButton* dash_button_construct (GType object_type) {
	DashButton * self = NULL;
	self = (DashButton*) g_object_new (object_type, NULL);
	return self;
}


DashButton* dash_button_new (void) {
	return dash_button_construct (TYPE_DASH_BUTTON);
}


static FadeTracker* dash_button_real_get_fade_tracker (Fadable* base) {
	FadeTracker* result;
	DashButton* self;
	FadeTracker* _tmp0_;
	self = (DashButton*) base;
	_tmp0_ = self->priv->_fade_tracker;
	result = _tmp0_;
	return result;
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static void dash_button_real_set_fade_tracker (Fadable* base, FadeTracker* value) {
	DashButton* self;
	FadeTracker* _tmp0_;
	FadeTracker* _tmp1_;
	self = (DashButton*) base;
	_tmp0_ = value;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_g_object_unref0 (self->priv->_fade_tracker);
	self->priv->_fade_tracker = _tmp1_;
	g_object_notify ((GObject *) self, "fade-tracker");
}


static GObject * dash_button_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties) {
	GObject * obj;
	GObjectClass * parent_class;
	DashButton * self;
	FadeTracker* _tmp0_;
	FadeTracker* _tmp1_;
	parent_class = G_OBJECT_CLASS (dash_button_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = DASH_BUTTON (obj);
	_tmp0_ = fade_tracker_new ((GtkWidget*) self);
	_tmp1_ = _tmp0_;
	fadable_set_fade_tracker ((Fadable*) self, _tmp1_);
	_g_object_unref0 (_tmp1_);
	return obj;
}


static void dash_button_class_init (DashButtonClass * klass) {
	dash_button_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (DashButtonPrivate));
	GTK_WIDGET_CLASS (klass)->draw = dash_button_real_draw;
	G_OBJECT_CLASS (klass)->get_property = _vala_dash_button_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_dash_button_set_property;
	G_OBJECT_CLASS (klass)->constructor = dash_button_constructor;
	G_OBJECT_CLASS (klass)->finalize = dash_button_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), DASH_BUTTON_FADE_TRACKER, g_param_spec_object ("fade-tracker", "fade-tracker", "fade-tracker", TYPE_FADE_TRACKER, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
}


static void dash_button_fadable_interface_init (FadableIface * iface) {
	dash_button_fadable_parent_iface = g_type_interface_peek_parent (iface);
	iface->get_fade_tracker = dash_button_real_get_fade_tracker;
	iface->set_fade_tracker = dash_button_real_set_fade_tracker;
}


static void dash_button_instance_init (DashButton * self) {
	self->priv = DASH_BUTTON_GET_PRIVATE (self);
}


static void dash_button_finalize (GObject* obj) {
	DashButton * self;
	self = DASH_BUTTON (obj);
	_g_object_unref0 (self->priv->_fade_tracker);
	G_OBJECT_CLASS (dash_button_parent_class)->finalize (obj);
}


GType dash_button_get_type (void) {
	static volatile gsize dash_button_type_id__volatile = 0;
	if (g_once_init_enter (&dash_button_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (DashButtonClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) dash_button_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DashButton), 0, (GInstanceInitFunc) dash_button_instance_init, NULL };
		static const GInterfaceInfo fadable_info = { (GInterfaceInitFunc) dash_button_fadable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		GType dash_button_type_id;
		dash_button_type_id = g_type_register_static (GTK_TYPE_BUTTON, "DashButton", &g_define_type_info, 0);
		g_type_add_interface_static (dash_button_type_id, TYPE_FADABLE, &fadable_info);
		g_once_init_leave (&dash_button_type_id__volatile, dash_button_type_id);
	}
	return dash_button_type_id__volatile;
}


static void _vala_dash_button_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	DashButton * self;
	self = DASH_BUTTON (object);
	switch (property_id) {
		case DASH_BUTTON_FADE_TRACKER:
		g_value_set_object (value, fadable_get_fade_tracker ((Fadable*) self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_dash_button_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	DashButton * self;
	self = DASH_BUTTON (object);
	switch (property_id) {
		case DASH_BUTTON_FADE_TRACKER:
		fadable_set_fade_tracker ((Fadable*) self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



