/* main-window.c generated by valac 0.15.1, the Vala compiler
 * generated from main-window.vala, do not modify */

/* -*- Mode: Vala; indent-tabs-mode: nil; tab-width: 4 -*-
 *
 * Copyright (C) 2011,2012 Canonical Ltd
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 3 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authors: Robert Ancell <robert.ancell@canonical.com>
 *          Michael Terry <michael.terry@canonical.com>
 */

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <cairo.h>
#include <stdlib.h>
#include <string.h>
#include <pango/pango.h>
#include <lightdm.h>
#include <atk/atk.h>
#include <glib/gi18n-lib.h>


#define TYPE_MAIN_WINDOW (main_window_get_type ())
#define MAIN_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MAIN_WINDOW, MainWindow))
#define MAIN_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MAIN_WINDOW, MainWindowClass))
#define IS_MAIN_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MAIN_WINDOW))
#define IS_MAIN_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MAIN_WINDOW))
#define MAIN_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MAIN_WINDOW, MainWindowClass))

typedef struct _MainWindow MainWindow;
typedef struct _MainWindowClass MainWindowClass;
typedef struct _MainWindowPrivate MainWindowPrivate;

#define TYPE_USER_LIST (user_list_get_type ())
#define USER_LIST(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_USER_LIST, UserList))
#define USER_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_USER_LIST, UserListClass))
#define IS_USER_LIST(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_USER_LIST))
#define IS_USER_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_USER_LIST))
#define USER_LIST_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_USER_LIST, UserListClass))

typedef struct _UserList UserList;
typedef struct _UserListClass UserListClass;

#define TYPE_BACKGROUND (background_get_type ())
#define BACKGROUND(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BACKGROUND, Background))
#define BACKGROUND_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BACKGROUND, BackgroundClass))
#define IS_BACKGROUND(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BACKGROUND))
#define IS_BACKGROUND_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BACKGROUND))
#define BACKGROUND_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BACKGROUND, BackgroundClass))

typedef struct _Background Background;
typedef struct _BackgroundClass BackgroundClass;

#define TYPE_MENU_BAR (menu_bar_get_type ())
#define MENU_BAR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MENU_BAR, MenuBar))
#define MENU_BAR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MENU_BAR, MenuBarClass))
#define IS_MENU_BAR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MENU_BAR))
#define IS_MENU_BAR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MENU_BAR))
#define MENU_BAR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MENU_BAR, MenuBarClass))

typedef struct _MenuBar MenuBar;
typedef struct _MenuBarClass MenuBarClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

#define TYPE_USER_ENTRY (user_entry_get_type ())
#define USER_ENTRY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_USER_ENTRY, UserEntry))
#define USER_ENTRY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_USER_ENTRY, UserEntryClass))
#define IS_USER_ENTRY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_USER_ENTRY))
#define IS_USER_ENTRY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_USER_ENTRY))
#define USER_ENTRY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_USER_ENTRY, UserEntryClass))

typedef struct _UserEntry UserEntry;
typedef struct _UserEntryClass UserEntryClass;
typedef struct _UserEntryPrivate UserEntryPrivate;

#define USER_LIST_TYPE_SCROLL_TARGET (user_list_scroll_target_get_type ())

struct _MainWindow {
	GtkWindow parent_instance;
	MainWindowPrivate * priv;
	UserList* user_list;
};

struct _MainWindowClass {
	GtkWindowClass parent_class;
};

struct _MainWindowPrivate {
	Background* background;
	MenuBar* menubar;
	guint change_background_timeout;
};

struct _UserEntry {
	GTypeInstance parent_instance;
	volatile int ref_count;
	UserEntryPrivate * priv;
	gchar* name;
	PangoLayout* layout;
	gchar* background;
	gboolean is_active;
	GList* keyboard_layouts;
};

struct _UserEntryClass {
	GTypeClass parent_class;
	void (*finalize) (UserEntry *self);
};

typedef enum  {
	USER_LIST_SCROLL_TARGET_START,
	USER_LIST_SCROLL_TARGET_END,
	USER_LIST_SCROLL_TARGET_UP,
	USER_LIST_SCROLL_TARGET_DOWN
} UserListScrollTarget;


static gpointer main_window_parent_class = NULL;
extern gboolean unity_greeter_test_mode;

GType main_window_get_type (void) G_GNUC_CONST;
GType user_list_get_type (void) G_GNUC_CONST;
GType background_get_type (void) G_GNUC_CONST;
GType menu_bar_get_type (void) G_GNUC_CONST;
#define MAIN_WINDOW_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_MAIN_WINDOW, MainWindowPrivate))
enum  {
	MAIN_WINDOW_DUMMY_PROPERTY
};
static void main_window_monitors_changed_cb (MainWindow* self, GdkScreen* screen);
static gboolean main_window_change_background_timeout_cb (MainWindow* self);
gboolean menu_bar_get_high_contrast (MenuBar* self);
gpointer user_entry_ref (gpointer instance);
void user_entry_unref (gpointer instance);
GParamSpec* param_spec_user_entry (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_user_entry (GValue* value, gpointer v_object);
void value_take_user_entry (GValue* value, gpointer v_object);
gpointer value_get_user_entry (const GValue* value);
GType user_entry_get_type (void) G_GNUC_CONST;
UserEntry* user_list_get_selected_entry (UserList* self);
void background_set_current_background (Background* self, const gchar* value);
static void main_window_change_background (MainWindow* self);
const gchar* background_get_current_background (Background* self);
static gboolean _main_window_change_background_timeout_cb_gsource_func (gpointer self);
static gboolean main_window_real_key_press_event (GtkWidget* base, GdkEventKey* event);
GType user_list_scroll_target_get_type (void) G_GNUC_CONST;
void user_list_scroll (UserList* self, UserListScrollTarget target);
MainWindow* main_window_new (void);
MainWindow* main_window_construct (GType object_type);
static GObject * main_window_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties);
void unity_greeter_add_style_class (GtkWidget* widget);
static void _main_window_monitors_changed_cb_gdk_screen_monitors_changed (GdkScreen* _sender, gpointer self);
Background* background_new (void);
Background* background_construct (GType object_type);
gboolean ug_settings_get_boolean (const gchar* key);
#define UG_SETTINGS_KEY_DRAW_GRID "draw-grid"
void background_set_draw_grid (Background* self, gboolean value);
gchar* ug_settings_get_string (const gchar* key);
#define UG_SETTINGS_KEY_BACKGROUND "background"
void background_set_default_background (Background* self, const gchar* value);
void background_set_logo (Background* self, const gchar* logo_path);
#define UG_SETTINGS_KEY_LOGO "logo"
MenuBar* menu_bar_new (Background* bg);
MenuBar* menu_bar_construct (GType object_type, Background* bg);
static void _main_window___lambda4_ (MainWindow* self);
static void __main_window___lambda4__g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self);
UserList* user_list_new (Background* bg, MenuBar* mb);
UserList* user_list_construct (GType object_type, Background* bg, MenuBar* mb);
static void _main_window___lambda5_ (MainWindow* self);
void menu_bar_set_layouts (MenuBar* self, GList* layouts);
static void __main_window___lambda5__user_list_user_displayed (UserList* _sender, gpointer self);
static void main_window_finalize (GObject* obj);


static void main_window_monitors_changed_cb (MainWindow* self, GdkScreen* screen) {
	GdkRectangle geometry = {0};
	GdkScreen* _tmp0_;
	GdkScreen* _tmp1_;
	gint _tmp2_ = 0;
	GdkRectangle _tmp3_ = {0};
	GdkRectangle _tmp4_;
	gint _tmp5_;
	GdkRectangle _tmp6_;
	gint _tmp7_;
	GdkRectangle _tmp8_;
	gint _tmp9_;
	GdkRectangle _tmp10_;
	gint _tmp11_;
	GdkRectangle _tmp12_;
	gint _tmp13_;
	GdkRectangle _tmp14_;
	gint _tmp15_;
	GdkRectangle _tmp16_;
	gint _tmp17_;
	GdkRectangle _tmp18_;
	gint _tmp19_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (screen != NULL);
	_tmp0_ = screen;
	_tmp1_ = screen;
	_tmp2_ = gdk_screen_get_primary_monitor (_tmp1_);
	gdk_screen_get_monitor_geometry (_tmp0_, _tmp2_, &_tmp3_);
	geometry = _tmp3_;
	_tmp4_ = geometry;
	_tmp5_ = _tmp4_.width;
	_tmp6_ = geometry;
	_tmp7_ = _tmp6_.height;
	_tmp8_ = geometry;
	_tmp9_ = _tmp8_.x;
	_tmp10_ = geometry;
	_tmp11_ = _tmp10_.y;
	g_debug ("main-window.vala:78: Monitor is %dx%d pixels at %d,%d", _tmp5_, _tmp7_, _tmp9_, _tmp11_);
	_tmp12_ = geometry;
	_tmp13_ = _tmp12_.width;
	_tmp14_ = geometry;
	_tmp15_ = _tmp14_.height;
	gtk_window_resize ((GtkWindow*) self, _tmp13_, _tmp15_);
	_tmp16_ = geometry;
	_tmp17_ = _tmp16_.x;
	_tmp18_ = geometry;
	_tmp19_ = _tmp18_.y;
	gtk_window_move ((GtkWindow*) self, _tmp17_, _tmp19_);
}


static gboolean main_window_change_background_timeout_cb (MainWindow* self) {
	gboolean result = FALSE;
	gchar* new_background_file = NULL;
	MenuBar* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	Background* _tmp8_;
	const gchar* _tmp9_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->menubar;
	_tmp1_ = menu_bar_get_high_contrast (_tmp0_);
	_tmp2_ = _tmp1_;
	if (_tmp2_) {
		_g_free0 (new_background_file);
		new_background_file = NULL;
	} else {
		UserList* _tmp3_;
		UserEntry* _tmp4_;
		UserEntry* _tmp5_;
		const gchar* _tmp6_;
		gchar* _tmp7_;
		_tmp3_ = self->user_list;
		_tmp4_ = user_list_get_selected_entry (_tmp3_);
		_tmp5_ = _tmp4_;
		_tmp6_ = _tmp5_->background;
		_tmp7_ = g_strdup (_tmp6_);
		_g_free0 (new_background_file);
		new_background_file = _tmp7_;
	}
	_tmp8_ = self->priv->background;
	_tmp9_ = new_background_file;
	background_set_current_background (_tmp8_, _tmp9_);
	self->priv->change_background_timeout = (guint) 0;
	result = FALSE;
	_g_free0 (new_background_file);
	return result;
}


static gboolean _main_window_change_background_timeout_cb_gsource_func (gpointer self) {
	gboolean result;
	result = main_window_change_background_timeout_cb (self);
	return result;
}


static void main_window_change_background (MainWindow* self) {
	Background* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->background;
	_tmp1_ = background_get_current_background (_tmp0_);
	_tmp2_ = _tmp1_;
	if (_tmp2_ != NULL) {
		guint _tmp3_;
		guint _tmp5_ = 0U;
		_tmp3_ = self->priv->change_background_timeout;
		if (_tmp3_ != ((guint) 0)) {
			guint _tmp4_;
			_tmp4_ = self->priv->change_background_timeout;
			g_source_remove (_tmp4_);
		}
		_tmp5_ = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 200, _main_window_change_background_timeout_cb_gsource_func, g_object_ref (self), g_object_unref);
		self->priv->change_background_timeout = _tmp5_;
	} else {
		main_window_change_background_timeout_cb (self);
	}
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static gboolean main_window_real_key_press_event (GtkWidget* base, GdkEventKey* event) {
	MainWindow * self;
	gboolean result = FALSE;
	GdkEventKey _tmp0_;
	guint _tmp1_;
	self = (MainWindow*) base;
	g_return_val_if_fail (event != NULL, FALSE);
	_tmp0_ = *event;
	_tmp1_ = _tmp0_.keyval;
	switch (_tmp1_) {
		case GDK_KEY_Page_Up:
		case GDK_KEY_KP_Page_Up:
		{
			UserList* _tmp2_;
			_tmp2_ = self->user_list;
			user_list_scroll (_tmp2_, USER_LIST_SCROLL_TARGET_START);
			break;
		}
		case GDK_KEY_Page_Down:
		case GDK_KEY_KP_Page_Down:
		{
			UserList* _tmp3_;
			_tmp3_ = self->user_list;
			user_list_scroll (_tmp3_, USER_LIST_SCROLL_TARGET_END);
			break;
		}
		case GDK_KEY_Up:
		case GDK_KEY_KP_Up:
		{
			UserList* _tmp4_;
			_tmp4_ = self->user_list;
			user_list_scroll (_tmp4_, USER_LIST_SCROLL_TARGET_UP);
			break;
		}
		case GDK_KEY_Down:
		case GDK_KEY_KP_Down:
		{
			UserList* _tmp5_;
			_tmp5_ = self->user_list;
			user_list_scroll (_tmp5_, USER_LIST_SCROLL_TARGET_DOWN);
			break;
		}
		case GDK_KEY_F10:
		{
			MenuBar* _tmp6_;
			_tmp6_ = self->priv->menubar;
			gtk_menu_shell_select_first ((GtkMenuShell*) _tmp6_, FALSE);
			break;
		}
		default:
		{
			GtkWidget* _tmp7_ = NULL;
			GtkWidget* _tmp8_;
			GtkWidget* focus;
			gboolean _tmp9_ = FALSE;
			GtkWidget* _tmp10_;
			gboolean _tmp12_;
			_tmp7_ = gtk_window_get_focus ((GtkWindow*) self);
			_tmp8_ = _g_object_ref0 (_tmp7_);
			focus = _tmp8_;
			_tmp10_ = focus;
			if (_tmp10_ != NULL) {
				GtkWidget* _tmp11_;
				_tmp11_ = focus;
				_tmp9_ = _tmp11_ != GTK_WIDGET (self);
			} else {
				_tmp9_ = FALSE;
			}
			_tmp12_ = _tmp9_;
			if (_tmp12_) {
				GtkWidget* _tmp13_;
				GdkEventKey _tmp14_;
				gboolean _tmp15_ = FALSE;
				_tmp13_ = focus;
				_tmp14_ = *event;
				g_signal_emit_by_name (_tmp13_, "key-press-event", &_tmp14_, &_tmp15_);
				result = _tmp15_;
				_g_object_unref0 (focus);
				return result;
			} else {
				result = FALSE;
				_g_object_unref0 (focus);
				return result;
			}
			_g_object_unref0 (focus);
		}
	}
	result = TRUE;
	return result;
}


MainWindow* main_window_construct (GType object_type) {
	MainWindow * self = NULL;
	self = (MainWindow*) g_object_new (object_type, NULL);
	return self;
}


MainWindow* main_window_new (void) {
	return main_window_construct (TYPE_MAIN_WINDOW);
}


static void _main_window_monitors_changed_cb_gdk_screen_monitors_changed (GdkScreen* _sender, gpointer self) {
	main_window_monitors_changed_cb (self, _sender);
}


static void _main_window___lambda4_ (MainWindow* self) {
	main_window_change_background (self);
}


static void __main_window___lambda4__g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self) {
	_main_window___lambda4_ (self);
}


static void _main_window___lambda5_ (MainWindow* self) {
	MenuBar* _tmp0_;
	UserList* _tmp1_;
	UserEntry* _tmp2_;
	UserEntry* _tmp3_;
	GList* _tmp4_;
	_tmp0_ = self->priv->menubar;
	_tmp1_ = self->user_list;
	_tmp2_ = user_list_get_selected_entry (_tmp1_);
	_tmp3_ = _tmp2_;
	_tmp4_ = _tmp3_->keyboard_layouts;
	menu_bar_set_layouts (_tmp0_, _tmp4_);
	main_window_change_background (self);
}


static void __main_window___lambda5__user_list_user_displayed (UserList* _sender, gpointer self) {
	_main_window___lambda5_ (self);
}


static GObject * main_window_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties) {
	GObject * obj;
	GObjectClass * parent_class;
	MainWindow * self;
	GdkColor bg_color = {0};
	GdkColor _tmp0_ = {0};
	GdkColor _tmp1_;
	AtkObject* _tmp2_ = NULL;
	const gchar* _tmp3_ = NULL;
	gboolean _tmp4_;
	Background* _tmp9_;
	Background* _tmp10_;
	Background* _tmp11_;
	gboolean _tmp12_ = FALSE;
	Background* _tmp13_;
	gchar* _tmp14_ = NULL;
	gchar* _tmp15_;
	Background* _tmp16_;
	gchar* _tmp17_ = NULL;
	gchar* _tmp18_;
	Background* _tmp19_;
	Background* _tmp20_;
	Background* _tmp21_;
	Background* _tmp22_;
	MenuBar* _tmp23_;
	MenuBar* _tmp24_;
	MenuBar* _tmp25_;
	MenuBar* _tmp26_;
	Background* _tmp27_;
	MenuBar* _tmp28_;
	MenuBar* _tmp29_;
	Background* _tmp30_;
	MenuBar* _tmp31_;
	UserList* _tmp32_;
	UserList* _tmp33_;
	UserList* _tmp34_;
	UserList* _tmp35_;
	UserList* _tmp36_;
	Background* _tmp37_;
	UserList* _tmp38_;
	UserList* _tmp39_;
	parent_class = G_OBJECT_CLASS (main_window_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = MAIN_WINDOW (obj);
	memset (&bg_color, 0, sizeof (GdkColor));
	gdk_color_parse ("#2C001E", &_tmp0_);
	bg_color = _tmp0_;
	_tmp1_ = bg_color;
	gtk_widget_modify_bg ((GtkWidget*) self, GTK_STATE_NORMAL, &_tmp1_);
	_tmp2_ = gtk_widget_get_accessible ((GtkWidget*) self);
	_tmp3_ = _ ("Login Screen");
	atk_object_set_name (_tmp2_, _tmp3_);
	gtk_window_set_has_resize_grip ((GtkWindow*) self, FALSE);
	unity_greeter_add_style_class ((GtkWidget*) self);
	_tmp4_ = unity_greeter_test_mode;
	if (_tmp4_) {
		gtk_window_resize ((GtkWindow*) self, 1024, 600);
	} else {
		GdkScreen* _tmp5_ = NULL;
		GdkScreen* _tmp6_;
		GdkScreen* screen;
		GdkScreen* _tmp7_;
		GdkScreen* _tmp8_;
		_tmp5_ = gtk_window_get_screen ((GtkWindow*) self);
		_tmp6_ = _g_object_ref0 (_tmp5_);
		screen = _tmp6_;
		_tmp7_ = screen;
		g_signal_connect_object (_tmp7_, "monitors-changed", (GCallback) _main_window_monitors_changed_cb_gdk_screen_monitors_changed, self, 0);
		_tmp8_ = screen;
		main_window_monitors_changed_cb (self, _tmp8_);
		_g_object_unref0 (screen);
	}
	_tmp9_ = background_new ();
	_tmp10_ = g_object_ref_sink (_tmp9_);
	_g_object_unref0 (self->priv->background);
	self->priv->background = _tmp10_;
	_tmp11_ = self->priv->background;
	_tmp12_ = ug_settings_get_boolean (UG_SETTINGS_KEY_DRAW_GRID);
	background_set_draw_grid (_tmp11_, _tmp12_);
	_tmp13_ = self->priv->background;
	_tmp14_ = ug_settings_get_string (UG_SETTINGS_KEY_BACKGROUND);
	_tmp15_ = _tmp14_;
	background_set_default_background (_tmp13_, _tmp15_);
	_g_free0 (_tmp15_);
	_tmp16_ = self->priv->background;
	_tmp17_ = ug_settings_get_string (UG_SETTINGS_KEY_LOGO);
	_tmp18_ = _tmp17_;
	background_set_logo (_tmp16_, _tmp18_);
	_g_free0 (_tmp18_);
	_tmp19_ = self->priv->background;
	gtk_widget_show ((GtkWidget*) _tmp19_);
	_tmp20_ = self->priv->background;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp20_);
	_tmp21_ = self->priv->background;
	unity_greeter_add_style_class ((GtkWidget*) _tmp21_);
	_tmp22_ = self->priv->background;
	_tmp23_ = menu_bar_new (_tmp22_);
	_tmp24_ = g_object_ref_sink (_tmp23_);
	_g_object_unref0 (self->priv->menubar);
	self->priv->menubar = _tmp24_;
	_tmp25_ = self->priv->menubar;
	g_signal_connect_object ((GObject*) _tmp25_, "notify::high-contrast", (GCallback) __main_window___lambda4__g_object_notify, self, 0);
	_tmp26_ = self->priv->menubar;
	gtk_widget_show ((GtkWidget*) _tmp26_);
	_tmp27_ = self->priv->background;
	_tmp28_ = self->priv->menubar;
	gtk_container_add ((GtkContainer*) _tmp27_, (GtkWidget*) _tmp28_);
	_tmp29_ = self->priv->menubar;
	unity_greeter_add_style_class ((GtkWidget*) _tmp29_);
	_tmp30_ = self->priv->background;
	_tmp31_ = self->priv->menubar;
	_tmp32_ = user_list_new (_tmp30_, _tmp31_);
	_tmp33_ = g_object_ref_sink (_tmp32_);
	_g_object_unref0 (self->user_list);
	self->user_list = _tmp33_;
	_tmp34_ = self->user_list;
	g_object_set ((GtkWidget*) _tmp34_, "expand", TRUE, NULL);
	_tmp35_ = self->user_list;
	g_signal_connect_object (_tmp35_, "user-displayed", (GCallback) __main_window___lambda5__user_list_user_displayed, self, 0);
	_tmp36_ = self->user_list;
	gtk_widget_show ((GtkWidget*) _tmp36_);
	_tmp37_ = self->priv->background;
	_tmp38_ = self->user_list;
	gtk_container_add ((GtkContainer*) _tmp37_, (GtkWidget*) _tmp38_);
	_tmp39_ = self->user_list;
	unity_greeter_add_style_class ((GtkWidget*) _tmp39_);
	return obj;
}


static void main_window_class_init (MainWindowClass * klass) {
	main_window_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (MainWindowPrivate));
	GTK_WIDGET_CLASS (klass)->key_press_event = main_window_real_key_press_event;
	G_OBJECT_CLASS (klass)->constructor = main_window_constructor;
	G_OBJECT_CLASS (klass)->finalize = main_window_finalize;
}


static void main_window_instance_init (MainWindow * self) {
	self->priv = MAIN_WINDOW_GET_PRIVATE (self);
	self->priv->change_background_timeout = (guint) 0;
}


static void main_window_finalize (GObject* obj) {
	MainWindow * self;
	self = MAIN_WINDOW (obj);
	_g_object_unref0 (self->user_list);
	_g_object_unref0 (self->priv->background);
	_g_object_unref0 (self->priv->menubar);
	G_OBJECT_CLASS (main_window_parent_class)->finalize (obj);
}


GType main_window_get_type (void) {
	static volatile gsize main_window_type_id__volatile = 0;
	if (g_once_init_enter (&main_window_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (MainWindowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) main_window_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MainWindow), 0, (GInstanceInitFunc) main_window_instance_init, NULL };
		GType main_window_type_id;
		main_window_type_id = g_type_register_static (GTK_TYPE_WINDOW, "MainWindow", &g_define_type_info, 0);
		g_once_init_leave (&main_window_type_id__volatile, main_window_type_id);
	}
	return main_window_type_id__volatile;
}



